//KSM.C by Ken Silverman (http://advsys.net/ken)
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

	//Added COM1 & VESA on 07/23/2000. Last touch: 55,418  10-20-95  1:49p
#define MIDICARD (2)             //0 = MPU401, 1 = PASMIDI, 2 = COM1
#define VIDEOCARD (2)            //0 = TSENG, 1 = S3, 2 = VESA

void interrupt far incount(void);
void (interrupt far *oldhand)();
unsigned long countstatus;
long count = 0;
int xchange,ychange,bstatus;
unsigned int numnotes = 0;
int click = 0, clicknum = 0, clickstat = 0, numchans;
int speed, drumstat = 0;
static unsigned char quant[20] =
{1,2,3,4,5,6,8,10,12,15,16,20,24,30,40,48,60,80,120,240};
static unsigned char inst[256][32];
static unsigned char trinst[16], trquant[16], trchan[16], trfut[16];
static unsigned char trvol[16], adlibchanoffs[9] = {0,1,2,8,9,10,16,17,18};
static unsigned char instpart[2][13][3] =
{
	2,4,15,2,0,15,3,4,15,3,0,15,0,5,1,0,4,1,0,0,15,10,0,0,
		0,6,1,1,0,63,1,6,3,0,7,1,4,0,3,
	7,4,15,7,0,15,8,4,15,8,0,15,5,5,1,5,4,1,5,0,15,10,1,7,
		5,6,1,6,0,63,6,6,3,5,7,1,9,0,3
};
static unsigned char spot[62] =
{
	0,212,255,207,255,201,196,255,190,255,185,255,179,
	174,255,168,255,163,157,255,152,255,146,255,141,
	135,255,130,255,124,119,255,113,255,108,255,102,
	97,255,91,255,86,80,255,75,255,69,255,64,
	58,255,53,255,47,42,255,36,255,31,255,25,
	20
};
static unsigned int adlibfreq[63] =
{
	0,
	2390,2411,2434,2456,2480,2506,2533,2562,2592,2625,2659,2695,
	3414,3435,3458,3480,3504,3530,3557,3586,3616,3649,3683,3719,
	4438,4459,4482,4504,4528,4554,4581,4610,4640,4673,4707,4743,
	5462,5483,5506,5528,5552,5578,5605,5634,5664,5697,5731,5767,
	6486,6507,6530,6552,6576,6602,6629,6658,6688,6721,6755,6791,
	7510
};
static unsigned char instbuf[11], tempinstbuf[11];
static unsigned char chanfreq[18], chantrack[18];
static unsigned long chanage[18];
static unsigned char mousav[226];
static char filelist[100][13], numfiles, oldfilenum;
static unsigned long note[8192];

main(int argc,char **argv)
{
	char ch, filename[80];
	int i, j, k, xchart, ychart;

	putcmd(0x3F);
	setup3812(0);
	if (setupmouse() != 0)
	{
		printf("Please install a Microsoft Mouse driver.");
		exit();
	}
	speed = 240;
	drumstatus(0);
	if (argc == 2)
	{
		speed = atoi(argv[1]);
		if (speed < 60)
			speed = 60;
		if (speed > 960)
			speed = 960;
	}
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
	ch = 0;
	loadinsts();
	for(i=0;i<16;i++)
	{
		trinst[i] = 0;
		trquant[i] = 240;
		trchan[i] = 0;
		trfut[i] = 0;
		trvol[i] = 50;
	}
	trinst[11]=253,trinst[12]=254,trinst[13]=255,trinst[14]=254,trinst[15]=255;
	trchan[0] = numchans;
	xchart = 0;
	ychart = 0;
	drawtextscreen();
	showobject(xchart,ychart,14);
	while (1)
	{
		ch = getch();
		if (ch == 27)
		{
			outext(11,30,2,"ͻ");
			outext(12,30,2,"                   ");
			outext(13,30,2,"                   ");
			outext(14,30,2,"ͼ");
			outext(12,32,4,"Are you sure you");
			outext(13,32,4,"want to quit KSM?");
			ch = 0;
			ch = getch();
			if ((ch == 'y') || (ch == 'Y'))
			{
				putcmd(0xFF);
				_asm \
				{
					mov ax, 0x3
					int 0x10
				}
				exit(0);
			}
			drawtextscreen();
			showobject(xchart,ychart,14);
			ch = 27;
		}
		if (((ch == 'N') || (ch == 'n')) && (xchart != 2))
		{
			outext(11,30,2,"ͻ");
			outext(12,30,2,"                   ");
			outext(13,30,2,"                   ");
			outext(14,30,2,"ͼ");
			outext(12,32,4,"Are you sure you");
			outext(13,32,4,"want a new song?");
			ch = getch();
			if ((ch == 'y') || (ch == 'Y'))
			{
				for(i=0;i<16;i++)
				{
					trinst[i] = 0;
					trquant[i] = 240;
					trchan[i] = 0;
					trfut[i] = 0;
					trvol[i] = 50;
				}
				trinst[11]=253,trinst[12]=254,trinst[13]=255,trinst[14]=254,trinst[15]=255;
				trchan[0] = numchans;
				xchart = 0;
				ychart = 0;
				numnotes = 0;
				for(i=0;i<8192;i++)
					note[i] = 0;
				drumstatus(0);
			}
			drawtextscreen();
			showobject(xchart,ychart,14);
			ch = 27;
		}
		if (((ch == 'L') || (ch == 'l')) && (xchart != 2))
		{
			outext(10,34,2,"ͻ");
			outext(11,34,2," Load what? ");
			outext(12,34,2,"Ķ");
			outext(13,34,2,"            ");
			outext(14,34,2,"ͼ");
			getdir();
			ch = 0;
			if (oldfilenum != -1)
				i = oldfilenum;
			else
				i = 0;
			while ((ch != 32) && (ch != 13) && (ch != 27))
			{
				outext(13,35,2,"            ");
				outext(13,35,2,filelist[i]);
				ch = getch();
				if (ch == 0)
				{
					ch = getch();
					if ((ch == 72) && (i > 0))
						i--;
					if ((ch == 80) && (i+1 < numfiles))
						i++;
					ch = 0;
				}
			}
			if (ch == 13)
			{
				oldfilenum = i;
				loadsong(filelist[i]);
			}
			if (ch == 32)
			{
				getfilename(filename);
				loadsong(filelist[i]);
			}
			drawtextscreen();
			showobject(xchart,ychart,14);
			ch = 27;
		}
		if (((ch == 'S') || (ch == 's')) && (xchart != 2))
		{
			outext(10,34,4,"ͻ");
			outext(11,34,4," Save what? ");
			outext(12,34,4,"Ķ");
			outext(13,34,4,"            ");
			outext(14,34,4,"ͼ");
			getdir();
			ch = 0;
			if (oldfilenum != -1)
				i = oldfilenum;
			else
				i = 0;
			while ((ch != 32) && (ch != 13) && (ch != 27))
			{
				outext(13,35,4,"            ");
				outext(13,35,4,filelist[i]);
				ch = getch();
				if (ch == 0)
				{
					ch = getch();
					if ((ch == 72) && (i > 0))
						i--;
					if ((ch == 80) && (i+1 < numfiles))
						i++;
					ch = 0;
				}
			}
			if (ch == 13)
			{
				oldfilenum = i;
				if (strlen(filelist[i]) > 0)
				{
					sortnotearray();
					savesong(filelist[i]);
				}
			}
			if (ch == 32)
			{
				getfilename(filename);
				if (strlen(filename) > 0)
				{
					sortnotearray();
					savesong(filename);
				}
			}
			drawtextscreen();
			showobject(xchart,ychart,14);
			ch = 27;
		}
		if ((ch == 32) && (xchart != 2))
			play(note[0]>>12);
		if (((ch == 'E') || (ch == 'e')) && (xchart != 2))
			if (xchart == 0)
			{
				editrack(ychart);
				drawtextscreen();
				showobject(xchart,ychart,14);
			}
		if (((ch == 'p') || (ch == 'P')) && (xchart == 0) && (trchan[ychart] > 0))
		{
			recordtrack(ychart,0);
			drawtextscreen();
			showobject(xchart,ychart,14);
		}
		if (ch == 13)
		{
			if ((xchart == 0) && (trchan[ychart] > 0))
			{
				recordtrack(ychart,1);
				drawtextscreen();
				showobject(xchart,ychart,14);
			}
			if ((xchart == 1) || (xchart == 2))
			{
				editinst(ychart);
				drawtextscreen();
				showobject(xchart,ychart,14);
			}
		}
		if (xchart == 2)
		{
			i = strlen(inst[trinst[ychart]]);
			if ((ch == 8) && (i > 0))
			{
				for(j=0;j<16;j++)
					if (trinst[ychart] == trinst[j])
						showobject(xchart,j,0);
				inst[trinst[ychart]][i-1] = 0;
				for(j=0;j<16;j++)
					if (trinst[ychart] == trinst[j])
						showobject(xchart,j,6+((ychart==j)<<3));
			}
			if ((ch >= 32) && (i < 20))
			{
				inst[trinst[ychart]][i] = ch;
				inst[trinst[ychart]][i+1] = 0;
				for(j=0;j<16;j++)
					if (trinst[ychart] == trinst[j])
						showobject(xchart,j,6+((ychart==j)<<3));
			}
		}
		if ((xchart == 1) && (ch >= 48) && (ch <= 57))
		{
			showobject(xchart,ychart,0);
			showobject(xchart+1,ychart,0);
			i = (unsigned)trinst[ychart];
			i = i * 10+(ch-48);
			if (i > 999)
				i = i%1000;
			if (i > 255)
				i = i%100;
			trinst[ychart] = (unsigned char)i;
			showobject(xchart,ychart,14);
			showobject(xchart+1,ychart,6);
		}
		if (ch == '+')
		{
			if ((xchart == 1) && (trinst[ychart] < 255))
			{
				showobject(xchart,ychart,0);
				showobject(xchart+1,ychart,0);
				trinst[ychart]++;
				showobject(xchart,ychart,14);
				showobject(xchart+1,ychart,6);
			}
			if ((xchart == 3) && (trquant[ychart] < 240))
			{
				showobject(xchart,ychart,0);
				j = -1;
				for(i=0;i<20;i++)
					if (trquant[ychart] == quant[i])
						j = i;
				trquant[ychart] = quant[j+1];
				showobject(xchart,ychart,14);
			}
			if ((xchart == 4) && (trchan[ychart] < 15))
			{
				showobject(xchart,ychart,0);
				trchan[ychart]++;
				showobject(xchart,ychart,14);
				if ((ychart >= 11) && (ychart <= 15))
				{
					for(i=11;i<16;i++)
					{
						trchan[i] = 1;
						showobject(xchart,i,6);
					}
					showobject(xchart,ychart,14);
					drumstatus(1);
				}
			}
			if (xchart == 5)
			{
				showobject(xchart,ychart,0);
				trfut[ychart] = 1 - trfut[ychart];
				showobject(xchart,ychart,14);
			}
			if ((xchart == 6) && (trvol[ychart] < 63))
			{
				showobject(xchart,ychart,0);
				trvol[ychart]++;
				switch(ychart)
				{
					case 11: outdata(0,0x40+19,trvol[11]^63); break;
					case 12: outdata(0,0x40+20,trvol[12]^63); break;
					case 13: outdata(0,0x40+18,trvol[13]^63); break;
					case 14: outdata(0,0x40+17,trvol[14]^63); break;
					case 15: outdata(0,0x40+21,trvol[15]^63); break;
				}
				showobject(xchart,ychart,14);
			}
		}
		if (ch == '-')
		{
			if ((xchart == 1) && (trinst[ychart] > 0))
			{
				showobject(xchart,ychart,0);
				showobject(xchart+1,ychart,0);
				trinst[ychart]--;
				showobject(xchart,ychart,14);
				showobject(xchart+1,ychart,6);
			}
			if ((xchart == 3) && (trquant[ychart] > 1))
			{
				showobject(xchart,ychart,0);
				j = -1;
				for(i=0;i<20;i++)
					if (trquant[ychart] == quant[i])
						j = i;
				trquant[ychart] = quant[j-1];
				showobject(xchart,ychart,14);
			}
			if ((xchart == 4) && (trchan[ychart] > 0))
			{
				showobject(xchart,ychart,0);
				trchan[ychart]--;
				showobject(xchart,ychart,14);
				if ((ychart >= 11) && (ychart <= 15))
				{
					for(i=11;i<16;i++)
					{
						trchan[i] = 0;
						showobject(xchart,i,6);
					}
					trchan[ychart] = 0;
					drumstatus(0);
				}
			}
			if (xchart == 5)
			{
				showobject(xchart,ychart,0);
				trfut[ychart] = 1 - trfut[ychart];
				showobject(xchart,ychart,14);
			}
			if ((xchart == 6) && (trvol[ychart] > 0))
			{
				showobject(xchart,ychart,0);
				trvol[ychart]--;
				switch(ychart)
				{
					case 11: outdata(0,0x40+19,trvol[11]^63); break;
					case 12: outdata(0,0x40+20,trvol[12]^63); break;
					case 13: outdata(0,0x40+18,trvol[13]^63); break;
					case 14: outdata(0,0x40+17,trvol[14]^63); break;
					case 15: outdata(0,0x40+21,trvol[15]^63); break;
				}
				showobject(xchart,ychart,14);
			}
		}
		if (ch == 0)
		{
			ch = getch();
			if ((ch == 75) && (xchart > 0))
			{
				showobject(xchart,ychart,6);
				xchart--;
				showobject(xchart,ychart,14);
			}
			if ((ch == 77) && (xchart < 6))
			{
				showobject(xchart,ychart,6);
				xchart++;
				showobject(xchart,ychart,14);
			}
			if ((ch == 72) && (ychart > 0))
			{
				showobject(xchart,ychart,6);
				ychart--;
				showobject(xchart,ychart,14);
			}
			if ((ch == 80) && (ychart < 15))
			{
				showobject(xchart,ychart,6);
				ychart++;
				showobject(xchart,ychart,14);
			}
			if (ch == 31)
				saveinsts();
			if ((ch == 83) && (xchart == 0))
			{
				i = 0;
				while(i < numnotes)
				{
					if ((int)((note[i]>>8)&15) == ychart)
						deletenote(i);
					i++;
				}
				trinst[ychart] = 0;
				if (ychart >= 11)
				{
					trinst[ychart] = 253;
					if ((ychart == 12) || (ychart == 14))
						trinst[ychart] = 254;
					if ((ychart == 13) || (ychart == 15))
						trinst[ychart] = 255;
				}
				trquant[ychart] = 240;
				if (ychart < 11)
					trchan[ychart] = 0;
				trfut[ychart] = 0;
				trvol[ychart] = 50;
				drawtextscreen();
				showobject(xchart,ychart,14);
			}
		}
	}
	putcmd(0xFF);
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
}

drawtextscreen()
{
	char buffer[82];
	int i;

	outext(4,1,7,"Ŀ");
	outext(5,1,7," Track         Instrument            Quantize  Status  (Future)  Volume ");
	outext(6,1,7,"Ĵ");
	for(i=7;i<23;i++)
	{
		outext(i,1,7,"                                                                       ");
		if (i < 18)
		{
			sprintf(buffer,"%d",i-7);
			outext(i,4,6,buffer);
		}
		if (i == 18) outext(i,2,6,"Bass  ");
		if (i == 19) outext(i,2,6,"Snare ");
		if (i == 20) outext(i,2,6,"TomTom");
		if (i == 21) outext(i,2,6,"HiHat ");
		if (i == 22) outext(i,2,6,"Cymbal");
		sprintf(buffer,"%d",trinst[i-7]);
		outext(i,12,6,buffer);
		outext(i,18,6,inst[trinst[i-7]]);
		sprintf(buffer,"%d",trquant[i-7]);
		outext(i,44,6,buffer);
		sprintf(buffer,"%d",trchan[i-7]);
		outext(i,54,6,buffer);
		sprintf(buffer,"%d",trfut[i-7]);
		outext(i,62,6,buffer);
		sprintf(buffer,"%d",trvol[i-7]);
		outext(i,72,6,buffer);
	}
	outext(23,1,7,"");
}

showobject(x, y, col)
int x, y, col;
{
	char buffer[82];

	if (x == 0)
	{
		if (y < 11)
		{
			sprintf(buffer,"%d",y);
			outext(y+7,4,col,buffer);
		}
		if (y == 11) outext(y+7,2,col,"Bass  ");
		if (y == 12) outext(y+7,2,col,"Snare ");
		if (y == 13) outext(y+7,2,col,"TomTom");
		if (y == 14) outext(y+7,2,col,"HiHat ");
		if (y == 15) outext(y+7,2,col,"Cymbal");
	}
	if (x == 1) sprintf(buffer,"%d",trinst[y]), outext(y+7,12,col,buffer);
	if (x == 2) outext(y+7,18,col,inst[trinst[y]]);
	if (x == 3) sprintf(buffer,"%d",trquant[y]), outext(y+7,44,col,buffer);
	if (x == 4) sprintf(buffer,"%d",trchan[y]), outext(y+7,54,col,buffer);
	if (x == 5) sprintf(buffer,"%d",trfut[y]), outext(y+7,62,col,buffer);
	if (x == 6) sprintf(buffer,"%d",trvol[y]), outext(y+7,72,col,buffer);
}

editrack(track)
int track;
{
	char ch;
	int i, j, k, l, dat, lastat, status, freq, noteadr, nextvol;
	long oldmousx, oldmousy, mousx, mousy, temp2;
	unsigned long temp, templong, timeofplace, topline, quanter;

#if (VIDEOCARD == 0)
	_asm \
	{
		mov ax, 0x38
		int 0x10
	}
#endif
#if (VIDEOCARD == 1)
	_asm \
	{
		mov ax, 0x4f02
		mov bx, 0x105
		int 0x10
	}
	outp(0x3d4,0x38); outp(0x3d5,0x48);           //S3 Extensions enable #1
	outp(0x3d4,0x39); outp(0x3d4,0xa5);           //S3 Extensions enable #2
	outp(0x3d4,0x31); outp(0x3d5,inp(0x3d5)|9);   //Init for start address
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f02
		mov bx, 0x105
		int 0x10
	}
#endif

	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
	ch = 0;
	for(i=0;i<11;i++)
		instbuf[i] = inst[trinst[track]][i+21];
	instbuf[1] = ((instbuf[1]&192)|(trvol[track])^63);
	for(i=0;i<numchans;i++)
	{
		setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
		chantrack[i] = track;
		chanage[i] = 0;
	}
	drumstatus(trchan[11]);
	for(i=0;i<=768;i+=256)
	{
		drawstaff(i);
		drawnotestaff(track,(unsigned long)((i>>8)*960));
	}
	mousx = 512;
	mousy = 384;
	savemouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
	hlin((unsigned)(mousx-7),(unsigned)(mousx+7),(unsigned)mousy,8);
	vlin((unsigned)mousx,(unsigned)(mousy-7),(unsigned)(mousy+7),8);
	lastat = 0x90;
	quanter = (240/trquant[track]);
	nextvol = 0;
	while (ch != 27)
	{
		while ((dat=getdata()) != -1)
		{
			if ((dat >= 0x80) && (dat != 0xfe))
				lastat = dat;
			if ((dat >= 0x00) && (dat < 0x80) && (lastat == 0x90))
			{
				status = getdata();
				adlib(templong,(int)track,(int)status,(int)(dat-35));
				if (status > 0)
				{
					timeofplace = (mousy>>8)*960+(mousx-32);
					temp = ((timeofplace+(quanter>>1)) / quanter) * quanter;
					noteadr = 0;
					while (((note[noteadr]>>12) < temp) && (noteadr < numnotes))
						noteadr++;
					freq = (int)dat-35;
					k = 0;
					for(i=noteadr-18;i<noteadr+18;i++)
						if ((i >= 0) && (i < numnotes))
						{
							templong = (((note[i]>>12)+(quanter>>1)) / quanter) * quanter;
							if ((templong == temp) && ((int)(note[i]&63) == freq) && ((int)((note[i]>>8)&15) == track))
							{
								l = i;
								k = 1;
								if ((note[i]&192) == 0)
									k = 2;
							}
						}
					if (k == 0)
					{
						if (nextvol == 0)
						{
							for(j=numnotes;j>noteadr;j--)
								note[j] = note[j-1];
							numnotes++;
							note[noteadr] = (unsigned long)(freq+64)+(unsigned long)(track<<8)+((unsigned long)(timeofplace)<<12);
							templong = (((note[noteadr]>>12)+(quanter>>1)) / quanter) * quanter;
							drawmouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
							drawnote(templong,(int)(note[noteadr]&192),(int)(note[noteadr]&63));
							savemouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
							hlin((unsigned)(mousx-7),(unsigned)(mousx+7),(unsigned)mousy,8);
							vlin((unsigned)mousx,(unsigned)(mousy-7),(unsigned)(mousy+7),8);
						}
					}
					if (k == 1)
					{
						note[l] &= 0xffffff3f;
						if (nextvol == 2) note[l] += 128L;
						if (nextvol == 3) note[l] += 192L;
						drawstaff(mousy&768);
						drawnotestaff(track,(unsigned long)((mousy>>8)*960));
						savemouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
						hlin((unsigned)(mousx-7),(unsigned)(mousx+7),(unsigned)mousy,8);
						vlin((unsigned)mousx,(unsigned)(mousy-7),(unsigned)(mousy+7),8);
					}
					if (k == 2)
					{
						deletenote(l);
						drawstaff(mousy&768);
						drawnotestaff(track,(unsigned long)((mousy>>8)*960));
						savemouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
						hlin((unsigned)(mousx-7),(unsigned)(mousx+7),(unsigned)mousy,8);
						vlin((unsigned)mousx,(unsigned)(mousy-7),(unsigned)(mousy+7),8);
					}
				}
			}
		}
		mouse(&xchange,&ychange,&bstatus);
		if ((xchange != 0) || (ychange != 0) || (bstatus != 0))
		{
			drawmouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
			oldmousx = mousx;
			oldmousy = mousy;
			if (xchange < -64)
				xchange = -64;
			if (xchange > 64)
				xchange = 64;
			if (ychange < -64)
				ychange = -64;
			if (ychange > 64)
				ychange = 64;
			mousx+=(long)xchange;
			mousy+=(long)ychange;
			if (mousx < 32)
				mousx = 32;
			if (mousx > 992)
				mousx = 992;
			if (mousy < 8)
				mousy = 8;
			savemouse((unsigned)(mousx-7),(unsigned)(mousy-7),(unsigned)(mousx+7),(unsigned)(mousy+7));
			hlin((unsigned)(mousx-7),(unsigned)(mousx+7),(unsigned)mousy,8);
			vlin((unsigned)mousx,(unsigned)(mousy-7),(unsigned)(mousy+7),8);
			topline = 0;
			if (mousy >= 384)
				topline = (mousy-384)&1023;

#if (VIDEOCARD == 0)
			outp(0x3d4,0x33); outp(0x3d5,(unsigned)topline>>8);
			outp(0x3d4,0xc); outp(0x3d5,(unsigned)topline&255);
#endif
#if (VIDEOCARD == 1)
			if ((1024-topline) > 768)
				linecompare(768);
			else
				linecompare(1023-topline);
			outp(0x3d4,0x31); outp(0x3d5,(unsigned)((inp(0x3d5)&0xcf)+((topline>>8)<<4)));
			outp(0x3d4,0xc); outp(0x3d5,(unsigned)topline&255);
#endif
#if (VIDEOCARD == 2)
			if ((1024-topline) > 768)
				linecompare(768);
			else
				linecompare(1023-topline);
			_asm \
			{
				mov ax, 0x4f07
				mov bx, 0
				mov cx, 0
				mov dx, topline
				int 0x10
			}
#endif

			if ((((oldmousy+128)|255) != ((mousy+128)|255)) && (mousy > 512))
			{
				if (mousy > oldmousy)
				{
					drawstaff((int)((mousy+384)&768));
					drawnotestaff(track,(unsigned long)(((mousy+384)>>8)*960));
				}
				if (mousy < oldmousy)
				{
					drawstaff((int)((mousy+640)&768));
					drawnotestaff(track,(unsigned long)(((mousy-384)>>8)*960));
				}
			}
		}
		if (kbhit() != 0)
		{
			ch = getch();
			if (ch == '1') nextvol = 3;
			if (ch == '2') nextvol = 0;
			if (ch == '3') nextvol = 2;
			if (ch == 0)
				getch();
			if (ch == 32)
				play(note[0]>>12);
			if (ch == 13)
			{
				temp2 = ((mousy-384)>>8)*960;
				if (temp2 < (note[0]>>12))
					temp2 = (note[0]>>12);
				if (temp2 < 0)
					temp2 = 0;
				play(temp2);
			}
		}
	}
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
}

startcount(freq)
int freq;
{
	unsigned int num;

	if (countstatus == 0)
	{
		num = (unsigned)((1193181.7 / (double)freq)+.5);
		_disable();
		outp(0x40,num&255); outp(0x40,num>>8);
		oldhand = _dos_getvect(0x8);
		_dos_setvect(0x8, incount);
		_enable();
		countstatus = 1;
	}
}

stopcount()
{
	_disable();
	outp(0x40,255); outp(0x40,255);
	_dos_setvect(0x8, oldhand);
	_enable();
	countstatus = 0;
}

void interrupt far incount()
{
	_disable();
	count++;
	click--;
	_asm \
	{
		in al, 97
		and al, 252
		out 97, al
	}
	if (click <= 0)
	{
		if (clickstat == 0)
		{
			_asm \
			{
				in al, 97
				or al, 3
				out 97, al
				mov al, 182
				out 67, al
				mov al, 0
				out 66, al
				mov dx, 0x3c8
				mov al, 0
				out dx, al
			}
			if (clicknum == 0)
				_asm \
				{
					mov al, 32
					out 66, al
					mov dx, 0x3c9
					mov al, 32
					out dx, al
					mov al, 0
					out dx, al
					out dx, al
				}
			if ((clicknum&1) == 1)
				_asm \
				{
					mov al, 16
					out 66, al
					mov dx, 0x3c9
					mov al, 0
					out dx, al
					out dx, al
					out dx, al
				}
			if (clicknum == 2)
				_asm \
				{
					mov al, 4
					out 66, al
					mov dx, 0x3c9
					mov al, 0
					out dx, al
					out dx, al
					mov al, 48
					out dx, al
				}
			clicknum = (clicknum+1)&3;
		}
		click = 120;
	}
	_enable();
	_asm \
	{
		mov al, 0x20
		out 0x20, al
	}
}

#if (MIDICARD == 2)
static int comport = 0;
pollcomon (int comnum, long comspeed, int commode)
{
	long divisor;
	int cnt;

	if ((comnum < 1) || (comnum > 4) || (comspeed <= 0L) || (comspeed > 115200L)) return(-1);

	comport = *(short far *)((long)comnum+comnum+0x3fe);  //get & verify comport
	if (!comport)
	{
		switch(comnum)
		{
			case 1: comport = 0x3f8; break;
			case 2: comport = 0x2f8; break;
			case 3: comport = 0x3e8; break;
			case 4: comport = 0x2e8; break;
		}
		if ((inp((comport)+5)&0x60) != 0x60) { comport = 0; return(-1); }
	}

	divisor = 115200L / comspeed;
	outp(comport+3,0x80);        //enable latch registers
	outp(comport+0,(int)divisor&255); //# = 115200 / bps
	outp(comport+1,(int)divisor>>8);

	outp(comport+3,commode);     //&h03 = N,8,1  &h1e = E,7,1
	outp(comport+4,0x3);         //modem control
	outp(comport+1,0);           //interrupt enable (D3)

	outp(comport+2,0x87);   //check for a 16550   0=1,64=4,128=8,192=14
	if ((inp(comport+2)&0xf8) == 0xc0) cnt = 16; else { cnt = 1; outp(comport+2,0); }
		//Clear any junk already in FIFO
	while ((inp(comport+5)&1) && (cnt)) { inp(comport); cnt--; }
	inp(comport+6); inp(comport+5); inp(comport+0); inp(comport+2);

	return(0);
}
#endif

getdata()
{
	int i;

#if (MIDICARD == 0)
	i = 256;
	while ((i > 0) && ((inp(0x331) & 0x80) != 0))
		i--;
	if (i == 0)
		return(-1);
	else
		return(inp(0x330));
#endif
#if (MIDICARD == 1)
		//if no data ready
	i = 256;
	while ((i > 0) && ((inp(0x1b88) & 0x4) == 0))
		i--;
	if (i == 0)
		return(-1);
	else
		return(inp(0x178a));
#endif
#if (MIDICARD == 2)
	if (comport == 0) return(-1);

	i = 256;
	while ((i > 0) && ((inp(comport+5) & 1) == 0))
		i--;
	if (i == 0)
		return(-1);
	else
		return(inp(comport));
#endif
#if (MIDICARD == -1)
	return(-1);
#endif
}

putdata(int data)
{
	int i;

#if (MIDICARD == 0)
	i = 256;
	while ((i > 0) && ((inp(0x331) & 0x40) != 0))
		i--;
	if (i == 0)
		return(-1);

	outp(0x330,data);
	return(data);
#endif
#if (MIDICARD == 1)
	i = 256;
	while ((i > 0) && ((inp(0x1b89) & 0xf0) == 0x10))
		i--;
	if (i == 0)
		return(-1);

	outp(0x178a,data);
	return(data);
#endif
#if (MIDICARD == 2)
	if (comport)
	{
		i = 4096;
		while ((i > 0) && (!(inp(comport+5)&32))) i--;
		if (i == 0) return(0);
		outp(comport,data);
	}
	return(data);
#endif
#if (MIDICARD == -1)
	return(-1);
#endif
}

putcmd(int data)
{
	int i;

#if (MIDICARD == 0)
	i = 256;
	while ((i > 0) && ((inp(0x331) & 0x40) != 0))
		i--;
	outp(0x331,data);
	i = 256;
	while ((i > 0) && ((getdata() & 0xfe) != 0))
		i--;
#endif
#if (MIDICARD == 1)
	if (data == 0x7f)
		outp(0x178b,1);
#endif
#if (MIDICARD == 2)
	if (data == 0x3f)
	{
			//(See COMEMU.BAS for original code)
		if (pollcomon(MIDICARD-1,38400,3) < 0) comport = 0;

			//Turn all notes off
		for(i=0;i<16;i++) { putdata((char)i+0xb0); putdata(0x7b); putdata(0); }

			//Local control off (take over keyboard completely!)
		putdata(0xb0); putdata(0x7a); putdata(0);
	}
	else
	{     //Local control on
		putdata(0xb0); putdata(0x7a); putdata(127);

		if (comport) { outp(comport+1,0); outp(comport+4,0); }
	}
#endif
}

rectfill(x1,y1,x2,y2,color)
int x1, y1, x2, y2;
char color;
{
	char pag;
	unsigned int lineleng, y, pos, col;

	if (x1 > x2)
	{
		y = x2; x2 = x1; x1 = y;
	}
	if (y1 > y2)
	{
		y = y2; y2 = y1; y1 = y;
	}
	lineleng = (x2-x1+1)>>1;
	pos = ((y1&63)<<10)+x1;
	pag = (y1>>6);
#if (VIDEOCARD == 0)
	outp(0x3cd,pag);
#endif
#if (VIDEOCARD == 1)
	outp(0x3d4,0x35); outp(0x3d5,pag);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, pag
		and dx, 15
		int 0x10
	}
#endif
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		cld
		mov al, color
		mov ah, al
		mov col, ax
	}
	if (((x2-x1)&1) != 0)
		for(y=y1;y<=y2;y++)
		{
			_asm \
			{
				mov di, pos
				mov ax, col
				mov cx, lineleng
				rep stosw
				add pos, 1024
				test pos, 64512
				jnz skip
				inc pag
			}
#if (VIDEOCARD == 0)
			outp(0x3cd,pag);
#endif
#if (VIDEOCARD == 1)
			outp(0x3d4,0x35); outp(0x3d5,pag);
#endif
#if (VIDEOCARD == 2)
			_asm \
			{
				mov ax, 0x4f05
				mov bx, 0
				mov dx, pag
				and dx, 15
				int 0x10
			}
#endif
			_asm \
			{
				skip:
			}
		}
	else
		for(y=y1;y<=y2;y++)
		{
			_asm \
			{
				mov di, pos
				mov ax, col
				mov cx, lineleng
				rep stosw
				stosb
				add pos, 1024
				test pos, 64512
				jnz skip2
				inc pag
			}
#if (VIDEOCARD == 0)
			outp(0x3cd,pag);
#endif
#if (VIDEOCARD == 1)
			outp(0x3d4,0x35); outp(0x3d5,pag);
#endif
#if (VIDEOCARD == 2)
			_asm \
			{
				mov ax, 0x4f05
				mov bx, 0
				mov dx, pag
				and dx, 15
				int 0x10
			}
#endif
			_asm \
			{
				skip2:
			}
		}
}

hlin(x1,x2,y,color)
int x1,x2,y;
char color;
{
	unsigned int lopos, lineleng;

	lineleng = (x2-x1)+1;
#if (VIDEOCARD == 0)
	outp(0x3cd,y>>6);
#endif
#if (VIDEOCARD == 1)
	outp(0x3d4,0x35); outp(0x3d5,y>>6);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, y
		mov cl, 6
		shr dx, cl
		and dx, 15
		int 0x10
	}
#endif
	lopos = ((unsigned int)(y&63)<<10)+x1;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov di, lopos
		mov cx, lineleng
		mov al, color
		cld
		rep stosb
	}
}

vlin(x,y1,y2,color)
int x,y1,y2;
char color;
{
	char pag;
	unsigned int pos, lineleng, ycount;

	pos = ((unsigned int)(y1&63)<<10)+x;
	pag = y1>>6;
#if (VIDEOCARD == 0)
	outp(0x3cd,pag);
#endif
#if (VIDEOCARD == 1)
	outp(0x3d4,0x35); outp(0x3d5,pag);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, pag
		and dx, 15
		int 0x10
	}
#endif
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
	}
	for(ycount=y1;ycount<=y2;ycount++)
	{
		_asm \
		{
			mov di, pos
			mov al, color
			stosb
			add pos, 1024
			test pos, 64512
			jnz skip3
			inc pag
		}
#if (VIDEOCARD == 0)
		outp(0x3cd,pag);
#endif
#if (VIDEOCARD == 1)
		outp(0x3d4,0x35); outp(0x3d5,pag);
#endif
#if (VIDEOCARD == 2)
		_asm \
		{
			mov ax, 0x4f05
			mov bx, 0
			mov dx, pag
			and dx, 15
			int 0x10
		}
#endif
		_asm \
		{
			skip3:
		}
	}
}

rectopen(x1,y1,x2,y2,color)
int x1,y1,x2,y2;
char color;
{
	unsigned int lopos, lineleng, ycount;

	lineleng = (x2-x1)+1;
#if (VIDEOCARD == 0)
	outp(0x3cd,y1>>6);
#endif
#if (VIDEOCARD == 1)
	outp(0x3d4,0x35); outp(0x3d5,y1>>6);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, y1
		mov cl, 6
		shr dx, cl
		and dx, 15
		int 0x10
	}
#endif
	lopos = ((unsigned int)(y1&63)<<10)+x1;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov di, lopos
		mov cx, lineleng
		mov al, color
		cld
		rep stosb
	}
	for(ycount=y1+1;ycount<y2;ycount++)
	{
		lopos += 1024;
		if (lopos < 1024)
		{
#if (VIDEOCARD == 0)
			outp(0x3cd,(ycount+1)>>6);
#endif
#if (VIDEOCARD == 1)
			outp(0x3d4,0x35); outp(0x3d5,(ycount+1)>>6);
#endif
#if (VIDEOCARD == 2)
			_asm \
			{
				mov ax, 0x4f05
				mov bx, 0
				mov dx, ycount
				inc dx
				mov cl, 6
				shr dx, cl
				and dx, 15
				int 0x10
			}
#endif
		}
		_asm \
		{
			mov di, lopos
			mov al, color
			stosb
			add di, lineleng
			dec di
			dec di
			stosb
		}
	}
	lopos += 1024;
	if (lopos < 1024)
	{
#if (VIDEOCARD == 0)
		outp(0x3cd,(ycount+1)>>6);
#endif
#if (VIDEOCARD == 1)
		outp(0x3d4,0x35); outp(0x3d5,(ycount+1)>>6);
#endif
#if (VIDEOCARD == 2)
		_asm \
		{
			mov ax, 0x4f05
			mov bx, 0
			mov dx, ycount
			inc dx
			mov cl, 6
			shr dx, cl
			and dx, 15
			int 0x10
		}
#endif
	}
	_asm \
	{
		mov di, lopos
		mov cx, lineleng
		mov al, color
		rep stosb
	}
}

savemouse(x1,y1,x2,y2)
unsigned int x1,y1,x2,y2;
{
	unsigned int lopos, lineleng, ycount, arrpos;

	lineleng = (x2-x1)+1;
#if (VIDEOCARD == 0)
	outp(0x3cd,(y1>>6)<<4);
#endif
#if (VIDEOCARD == 1)
	outp(0x3d4,0x35); outp(0x3d5,y1>>6);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, y1
		mov cl, 6
		shr dx, cl
		and dx, 15
		int 0x10
	}
#endif
	lopos = ((unsigned int)(y1&63)<<10)+x1;
	arrpos = 0;
	for(ycount=y1;ycount<=y2;ycount++)
	{
		_asm \
		{
			mov ax, 0xa000
			mov es, ax
			mov di, lopos
			mov si, offset mousav
			add si, arrpos
			mov cx, lineleng
startmousave:
			mov al, es:[di]
			mov ds:[si], al
			inc di
			inc si
			loop startmousave
		}
		arrpos += lineleng;
		lopos += 1024;
		if (lopos < 1024)
		{
#if (VIDEOCARD == 0)
			outp(0x3cd,(((ycount+1)>>6)<<4)&240);
#endif
#if (VIDEOCARD == 1)
			outp(0x3d4,0x35); outp(0x3d5,(ycount+1)>>6);
#endif
#if (VIDEOCARD == 2)
			_asm \
			{
				mov ax, 0x4f05
				mov bx, 0
				mov dx, ycount
				inc dx
				mov cl, 6
				shr dx, cl
				and dx, 15
				int 0x10
			}
#endif
		}
	}
}

drawmouse(x1,y1,x2,y2)
unsigned int x1,y1,x2,y2;
{
	unsigned int lopos, lineleng, ycount, arrpos;

	lineleng = (x2-x1)+1;
#if (VIDEOCARD == 0)
	 outp(0x3cd,y1>>6);
#endif
#if (VIDEOCARD == 1)
	 outp(0x3d4,0x35); outp(0x3d5,y1>>6);
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0x4f05
		mov bx, 0
		mov dx, y1
		mov cl, 6
		shr dx, cl
		and dx, 15
		int 0x10
	}
#endif

	lopos = ((unsigned int)(y1&63)<<10)+x1;
	arrpos = 0;
	for(ycount=y1;ycount<=y2;ycount++)
	{
		_asm \
		{
			mov ax, 0xa000
			mov es, ax
			mov di, lopos
			mov si, offset mousav
			add si, arrpos
			mov cx, lineleng
			rep movsb
		}
		arrpos += lineleng;
		lopos += 1024;
		if (lopos < 1024)
		{
#if (VIDEOCARD == 0)
			 outp(0x3cd,((ycount+1)>>6)&15);
#endif
#if (VIDEOCARD == 1)
			 outp(0x3d4,0x35); outp(0x3d5,((ycount+1)>>6)&15);
#endif
#if (VIDEOCARD == 2)
			_asm \
			{
				mov ax, 0x4f05
				mov bx, 0
				mov dx, ycount
				inc dx
				mov cl, 6
				shr dx, cl
				and dx, 15
				int 0x10
			}
#endif
		}
	}
}

line(x1,y1,x2,y2,color)
int x1,y1,x2,y2;
char color;
{
	int dx, dy, incr1, incr2, d, x, y, xend, yend, yinc, xinc;

	dx = abs(x2 - x1);
	dy = abs(y2 - y1);
	if (dx >= dy)
	{
		if (x1 > x2)
		{
			x = x2; y = y2; xend = x1;
			if (dy == 0)
				yinc = 0;
			else
			{
				if (y2 > y1)
					yinc = -1;
				else
					yinc = 1;
			}
		}
		else
		{
			x = x1; y = y1; xend = x2;
			if (dy == 0)
				yinc = 0;
			else
			{
				if (y2 > y1)
					yinc = 1;
				else
					yinc = -1;
			}
		}
		incr1 = 2*dy; d = incr1-dx; incr2 = 2 * (dy-dx);
		pixel(x,y,color);
		while (x < xend)
		{
			x++;
			if (d < 0)
				d += incr1;
			else
			{
				y += yinc;
				d = d + incr2;
			}
			pixel(x,y,color);
		}
	}
	else
	{
		if (y1 > y2)
		{
			x = x2; y = y2; yend = y1;
			if (dx == 0)
				xinc = 0;
			else
			{
				if (x2 > x1)
					xinc = -1;
				else
					xinc = 1;
			}
		}
		else
		{
			x = x1; y = y1; yend = y2;
			if (dx == 0)
				xinc = 0;
			else
			{
				if (x2 > x1)
					xinc = 1;
				else
					xinc = -1;
			}
		}
		incr1 = 2*dx; d = incr1-dy; incr2 = 2 * (dx-dy);
		pixel(x,y,color);
		while (y < yend)
		{
			y++;
			if (d < 0)
				d += incr1;
			else
			{
				x += xinc;
				d += incr2;
			}
			pixel(x,y,color);
		}
	}
}

pixel(x,y,color)
int x,y;
char color;
{
#if (VIDEOCARD == 0)
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov ax, y
		mov cl, 6
		shr ax, cl
		mov dx, 0x3cd
		out dx, al
		mov ax, y
		and ax, 63
		mov cl, 10
		shl ax, cl
		add ax, x
		mov di, ax
		mov al, color
		stosb
	}
#endif
#if (VIDEOCARD == 1)
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov dx, 0x3d4
		mov al, 0x35
		out dx, al
		inc dx
		mov ax, y
		mov cl, 6
		shr ax, cl
		out dx, al
		mov ax, y
		and ax, 63
		mov cl, 10
		shl ax, cl
		add ax, x
		mov di, ax
		mov al, color
		stosb
	}
#endif
#if (VIDEOCARD == 2)
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov ax, 0x4f05
		mov bx, 0
		mov dx, y
		mov cl, 6
		shr dx, cl
		and dx, 15
		int 0x10
		mov ax, y
		and ax, 63
		mov cl, 10
		shl ax, cl
		add ax, x
		mov di, ax
		mov al, color
		stosb
	}
#endif
}

ellipse(xc, yc, rx, ry, color, fill)
int xc, yc, rx, ry, fill;
char color;
{
	int x, y, xx, yy, d, dx, dy, oldx, oldy;

	x = 0;
	xx = 0;
	dx = 0;
	dy = 0;
	oldx = -1;
	oldy = -1;
	if (rx >= ry)
	{
		d = 3 - (rx<<1);
		y = rx;
		yy = ry-1;
		while (x <= y)
		{
			if (fill == 0)
			{
				pixel(xc+x, yc+yy, color);
				pixel(xc+x, yc-yy, color);
				pixel(xc-x, yc+yy, color);
				pixel(xc-x, yc-yy, color);
				pixel(xc+y, yc+xx, color);
				pixel(xc+y, yc-xx, color);
				pixel(xc-y, yc+xx, color);
				pixel(xc-y, yc-xx, color);
			}
			else
			{
				if (oldy != yy)
				{
					hlin(xc-x,xc+x,yc-yy,color);
					hlin(xc-x,xc+x,yc+yy,color);
				}
				if (oldx != xx)
				{
					hlin(xc-y,xc+y,yc-xx,color);
					hlin(xc-y,xc+y,yc+xx,color);
				}
				oldx = xx;
				oldy = yy;
			}
			if (d < 0)
				d += (x<<2) + 6;
			else
			{
				d += ((x - y)<<2) + 10;
				y--;
				dy += ry;
				if (dy >= rx)
				{
					dy -= rx;
					yy--;
				}
			}
			x++;
			dx += ry;
			if (dx >= rx)
			{
				dx -= rx;
				xx++;
			}
		}
	}
	if (rx < ry)
	{
		d = 3 - (ry<<1);
		y = ry;
		yy = rx-1;
		while (x <= y)
		{
			if (fill == 0)
			{
				pixel(xc+xx, yc+y, color);
				pixel(xc+xx, yc-y, color);
				pixel(xc-xx, yc+y, color);
				pixel(xc-xx, yc-y, color);
				pixel(xc+yy, yc+x, color);
				pixel(xc+yy, yc-x, color);
				pixel(xc-yy, yc+x, color);
				pixel(xc-yy, yc-x, color);
			}
			else
			{
				if (oldy != y)
				{
					hlin(xc-xx,xc+xx,yc-y,color);
					hlin(xc-xx,xc+xx,yc+y,color);
				}
				if (oldx != x)
				{
					hlin(xc-yy,xc+yy,yc-x,color);
					hlin(xc-yy,xc+yy,yc+x,color);
				}
				oldx = x;
				oldy = y;
			}
			if (d < 0)
				d += (x<<2) + 6;
			else
			{
				d += ((x - y)<<2) + 10;
				y--;
				dy += rx;
				if (dy >= ry)
				{
					dy -= ry;
					yy--;
				}
			}
			x++;
			dx += rx;
			if (dx >= ry)
			{
				dx -= ry;
				xx++;
			}
		}
	}
}

drawstaff(i)
int i;
{
	rectfill(0,i,1023,i+255,7);
	hlin(0,992,i+86,6);
	hlin(0,992,i+97,6);
	hlin(0,992,i+108,6);
	hlin(0,992,i+119,6);
	hlin(0,992,i+130,6);
	hlin(0,992,i+152,6);
	hlin(0,992,i+163,6);
	hlin(0,992,i+174,6);
	hlin(0,992,i+185,6);
	hlin(0,992,i+196,6);
	vlin(32,i+86,i+196,6);
	vlin(272,i+86,i+196,6);
	vlin(512,i+86,i+196,6);
	vlin(752,i+86,i+196,6);
	vlin(992,i+86,i+196,6);
	ellipse(8,i+130,3,3,8,1);
	line(8,i+130,8,i+132,8);
	line(8,i+132,13,i+137,8);
	line(13,i+137,18,i+132,8);
	line(18,i+132,8,i+80,8);
	line(8,i+80,13,i+75,8);
	line(13,i+75,18,i+80,8);
	line(18,i+80,18,i+90,8);
	line(18,i+90,3,i+105,8);
	line(3,i+105,3,i+115,8);
	line(3,i+115,8,i+117,8);
	line(8,i+117,13,i+120,8);
	line(13,i+120,18,i+117,8);
	line(18,i+117,23,i+113,8);
	line(23,i+113,23,i+105,8);
	line(23,i+105,18,i+100,8);
	line(18,i+100,12,i+105,8);
	ellipse(6,i+157,3,3,8,1);
	line(3,i+157,12,i+152,8);
	line(12,i+150,18,i+157,8);
	line(18,i+157,18,i+162,8);
	line(18,i+162,10,i+180,8);
	ellipse(24,i+155,2,2,8,1);
	ellipse(24,i+167,2,2,8,1);
}

drawnotestaff(track,countstart)
int track;
unsigned long countstart;
{
	int i;
	unsigned long templong, quanter;

	quanter = (240/trquant[track]);
	i = 0;
	templong = (((note[i]>>12)+(quanter>>1)) / quanter) * quanter;
	while ((templong < countstart) && (i < numnotes))
	{
		i++;
		templong = (((note[i]>>12)+(quanter>>1)) / quanter) * quanter;
	}
	while ((templong < countstart+960) && (i < numnotes))
	{
		if ((int)((note[i]>>8)&15) == track)
			drawnote(templong,(int)(note[i]&192),(int)(note[i]&63));
		i++;
		templong = (((note[i]>>12)+(quanter>>1)) / quanter) * quanter;
	}
}

drawnote(countval,status,freq)
long countval;
int status,freq;
{
	char col;
	int i, j;

	i = (int)(countval%960)+32;
	if (status > 0)
	{
		col = 8;
		if ((status&192) == 128) col = 1;
		if ((status&192) == 192) col = 4;
		if (spot[freq] != 255)
		{
			j = (int)spot[freq]+(((int)(countval/960)&3)<<8)+5;
			ellipse(i,j,4,4,col,1);
			vlin(i+5,j-15,j,8);
		}
		else
		{
			j = (int)spot[freq-1]+(((int)(countval/960)&3)<<8)+5;
			ellipse(i,j,4,4,col,1);
			vlin(i+5,j-15,j,8);
			vlin(i-7,j-4,j+4,8);
			vlin(i-9,j-4,j+4,8);
			line(i-10,j-1,i-6,j-3,8);
			line(i-10,j+3,i-6,j+1,8);
		}
	}
	if (status == 0)
	{
		if (spot[freq] == 255)
			freq--;
		j = (int)spot[freq]+(((int)(countval/960)&3)<<8)+5;
		line(i-2,j-2,i+2,j+2,4);
		line(i+2,j-2,i-2,j+2,4);
	}
}

linecompare(lin)
unsigned int lin;
{
	outp(0x3d4,0x18); outp(0x3d5,lin&255);
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&239)|((lin&256)>>4));
	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&191)|((lin&512)>>3));
}

outext(y,x,col,buf)
unsigned char y, x, col, buf[82];
{
	int i;
	unsigned int j, plc;

	plc = ((((int)y<<6)+((int)y<<4)+(int)x)<<1)-162;
	for(i=0;i<strlen(buf);i++)
	{
		j = buf[i];
		_asm \
		{
			mov ax, 0xb800
			mov es, ax
			mov di, plc
			cld
			mov al, j
			stosb
			mov al, col
			stosb
		}
		plc+=2;
	}
}

loadinsts()
{
	char buffer[35];
	int infile, i, j;

	if((infile=open("insts.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
	{
		printf("I cannot load insts.dat!");
		exit(0);
	}
	for(i=0;i<256;i++)
	{
		read(infile,&buffer,33);
		for(j=0;j<20;j++)
			inst[i][j] = buffer[j];
		inst[i][20] = 0;
		for(j=21;j<32;j++)
			inst[i][j] = buffer[j-1];
	}
	close(infile);
}

saveinsts()
{
	char buffer[35];
	int infile, i, j;

	if((infile=open("insts.dat",O_BINARY|O_WRONLY,S_IWRITE))==-1)
	{
		printf("I cannot save insts.dat!");
		exit(0);
	}
	for(i=0;i<256;i++)
	{
		for(j=0;j<20;j++)
			buffer[j] = inst[i][j];
		for(j=21;j<32;j++)
			buffer[j-1] = inst[i][j];
		buffer[31] = 13;
		buffer[32] = 10;
		write(infile,&buffer,33);
	}
	close(infile);
}

editinst(ychrt)
int ychrt;
{
	int instr, i, j, xtable, ytable, lastat, status, dat, oldinst;
	char ch, buffer[82], oldinstuff[11];
	unsigned long templong;

	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
	instr = trinst[ychrt];
	oldinst = instr;
	lastat = 0x90;
	for(i=0;i<11;i++)
	{
		instbuf[i] = inst[instr][i+21];
		oldinstuff[i] = instbuf[i];
	}
	ch = 0;
	draweditinst(instr);
	xtable = 0;
	ytable = 0;
	templong = 0;
	sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
	outext(ytable+7,40+xtable*26,14,buffer);
	for(i=0;i<numchans;i++)
	{
		setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	drumstatus(trchan[11]);
	while ((ch != 13) && (ch != 27))
	{
		while ((dat=getdata()) != -1)
		{
			if ((dat >= 0x80) && (dat != 0xfe))
				lastat = dat;
			if ((dat >= 0x00) && (dat < 0x80) && (lastat == 0x90))
			{
				status = getdata();
				if (ychrt >= 11)
					adlib(templong,ychrt,(int)status,(int)(dat-35)), templong++;
				else
					adlib(templong,0,(int)status,(int)(dat-35)), templong++;
			}
		}
		if (kbhit() != 0)
		{
			ch = getch();
			i = (instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2];
			if (ch == 0)
			{
				ch = getch();
				if (((ch == 75) && (xtable == 1)) || ((ch == 77) && (xtable == 0)))
				{
					sprintf(buffer,"%d",i);
					outext(ytable+7,40+xtable*26,6,buffer);
					xtable = 1 - xtable;
					if ((xtable == 0) && (ytable == 7))
						xtable = 1 - xtable;
					sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
					outext(ytable+7,40+xtable*26,14,buffer);
				}
				if ((ch == 72) && (ytable > 0))
				{
					sprintf(buffer,"%d",i);
					outext(ytable+7,40+xtable*26,6,buffer);
					ytable--;
					if ((xtable == 0) && (ytable == 7))
						ytable--;
					sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
					outext(ytable+7,40+xtable*26,14,buffer);
				}
				if ((ch == 80) && (ytable < 12))
				{
					sprintf(buffer,"%d",i);
					outext(ytable+7,40+xtable*26,6,buffer);
					ytable++;
					if ((xtable == 0) && (ytable == 7))
						ytable++;
					sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
					outext(ytable+7,40+xtable*26,14,buffer);
				}
				if (((ch == 73) && (instr > 0)) || ((ch == 81) && (instr < 255)))
				{
					for(i=0;i<11;i++)
						inst[instr][i+21] = instbuf[i];
					if (ch == 73)
						instr--;
					if (ch == 81)
						instr++;
					for(i=0;i<11;i++)
						instbuf[i] = inst[instr][i+21];
					trinst[ychrt] = instr;
					draweditinst(instr);
					sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
					outext(ytable+7,40+xtable*26,14,buffer);
					for(i=0;i<numchans;i++)
					{
						setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
						chanfreq[i] = 0;
					}
					drumstatus(trchan[11]);
				}
				ch = 0;
			}
			if ((ch == 'm') || (ch == 'M'))
				for(i=0;i<11;i++)
					tempinstbuf[i] = instbuf[i];
			if ((ch == 'p') || (ch == 'P'))
			{
				for(i=0;i<11;i++)
					instbuf[i] = tempinstbuf[i];
				draweditinst(instr);
				sprintf(buffer,"%d",(instbuf[instpart[xtable][ytable][0]]>>instpart[xtable][ytable][1])&instpart[xtable][ytable][2]);
				outext(ytable+7,40+xtable*26,14,buffer);
				for(i=0;i<numchans;i++)
				{
					setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
					chanfreq[i] = 0;
				}
			}
			if ((ch == '+') && (i < instpart[xtable][ytable][2]))
			{
				 sprintf(buffer,"%d",i);
				 outext(ytable+7,40+xtable*26,0,buffer);
				 instbuf[instpart[xtable][ytable][0]]+=(1<<instpart[xtable][ytable][1]);
				 if (ychrt >= 11)
					 inst[trinst[ychrt]][instpart[xtable][ytable][0]+21]+=(1<<instpart[xtable][ytable][1]);
				 sprintf(buffer,"%d",i+1);
				 outext(ytable+7,40+xtable*26,14,buffer);
				 for(i=0;i<numchans;i++)
					 setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
				 drumstatus(trchan[11]);
			}
			if ((ch == '-') && (i > 0))
			{
				 sprintf(buffer,"%d",i);
				 outext(ytable+7,40+xtable*26,0,buffer);
				 instbuf[instpart[xtable][ytable][0]]-=(1<<instpart[xtable][ytable][1]);
				 if (ychrt >= 11)
					 inst[trinst[ychrt]][instpart[xtable][ytable][0]+21]-=(1<<instpart[xtable][ytable][1]);
				 sprintf(buffer,"%d",i-1);
				 outext(ytable+7,40+xtable*26,14,buffer);
				 for(i=0;i<numchans;i++)
					 setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
				 drumstatus(trchan[11]);
			}
		}
	}
	if (ch == 13)
	{
		for(i=0;i<11;i++)
			inst[instr][i+21] = instbuf[i];
	}
	else
	{
		for(i=0;i<11;i++)
			inst[instr][i+21] = oldinstuff[i];
		trinst[ychrt] = oldinst;
	}
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
}

draweditinst(instr)
int instr;
{
	char buffer[82];
	int i, j;

	outext(4,1,7, "Ŀ");
	outext(5,1,7, "                                Carrier Cell             Modulator Cell     ");
	outext(6,1,7, "Ĵ");
	outext(7,1,7, " Attack rate                                                                ");
	outext(8,1,7, " Decay rate                                                                 ");
	outext(9,1,7, " Sustain level                                                              ");
	outext(10,1,7," Release rate                                                               ");
	outext(11,1,7," Sustaining sound                                                           ");
	outext(12,1,7," Envelope scaling                                                           ");
	outext(13,1,7," Frequency multiplier                                                       ");
	outext(14,1,7," Modulation Feedback                               ");
	outext(15,1,7," Pitch Vibrato                                                              ");
	outext(16,1,7," Output Level                                                               ");
	outext(17,1,7," Level Scaling                                                              ");
	outext(18,1,7," Amplitude Vibrato                                                          ");
	outext(19,1,7," Wave Form                                                                  ");
	outext(20,1,7,"");
	outext(5,3,14,inst[instr]);
	for(i=0;i<2;i++)
		for(j=0;j<13;j++)
		{
			sprintf(buffer,"%d",(instbuf[instpart[i][j][0]]>>instpart[i][j][1])&instpart[i][j][2]);
			if ((i != 0) || (j != 7))
				outext(j+7,40+i*26,6,buffer);
		}
}

setup3812(synth)
unsigned char synth;
{
	outdata(synth,0x1,32);  //clear test stuff
	outdata(synth,0x4,0);  //reset
	outdata(synth,0x8,0);  //2-operator synthesis
}

adlib(thecount,track,status,freq)
unsigned long thecount;
int track, freq;
{
	int i, chan, drumnum, volevel, volval;
	unsigned long temp;

	if (status == 0)
	{
		chan = 0;
		while (((chanfreq[chan] != freq) || (chantrack[chan] != track)) && (chan < numchans))
			chan++;
		if (chan < numchans)
		{
			outdata(0,0xa0+chan,adlibfreq[freq]&255);
			outdata(0,0xb0+chan,(adlibfreq[freq]>>8)&223);
			chanfreq[chan] = 0;
			chanage[chan] = 0;
		}
	}
	else
	{
		if ((status < 1) || (status > 3))
			status = 1;
		volevel = trvol[track];
		if (status == 2)
		{
			volevel -= 4;
			if (volevel < 0)
				volevel = 0;
		}
		if (status == 3)
		{
			volevel += 4;
			if (volevel > 63)
				volevel = 63;
		}
		if (track < 11)
		{
			temp = 0;
			chan = numchans;
			for(i=0;i<numchans;i++)
				if ((thecount - chanage[i] >= temp) && (chantrack[i] == track))
				{
					temp = thecount - chanage[i];
					chan = i;
				}
			if (chan < numchans)
			{
				outdata(0,0xa0+chan,0);
				outdata(0,0xb0+chan,0);
				volval = (inst[trinst[track]][1+21]&192)+(volevel^63);
				outdata(0,0x40+adlibchanoffs[chan]+3,volval);
				outdata(0,0xa0+chan,adlibfreq[freq]&255);
				outdata(0,0xb0+chan,(adlibfreq[freq]>>8)|32);
				chanfreq[chan] = freq;
				chanage[chan] = thecount;
			}
		}
		if ((track >= 11) && ((drumstat&32) > 0))
		{
			freq = adlibfreq[freq];
			switch(track)
			{
				case 11: drumnum = 16; chan = 6; freq -= 2048; break;
				case 12: drumnum = 8; chan = 7; freq -= 2048; break;
				case 13: drumnum = 4; chan = 8; break;
				case 14: drumnum = 2; chan = 8; break;
				case 15: drumnum = 1; chan = 7; freq -= 2048; break;
			}
			outdata(0,0xa0+chan,freq&255);
			outdata(0,0xb0+chan,(freq>>8)&223);
			outdata(0,0xbd,drumstat & (255-drumnum));
			drumstat |= drumnum;
			if ((track == 11) || (track == 12) || (track == 14))
			{
				volval = (inst[trinst[track]][1+21]&192)+(volevel^63);
				outdata(0,0x40+adlibchanoffs[chan]+3,volval);
			}
			else
			{
				volval = (inst[trinst[track]][6+21]&192)+(volevel^63);
				outdata(0,0x40+adlibchanoffs[chan],volval);
			}
			outdata(0,0xbd,drumstat);
		}
	}
}

setinst(synth,chan,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10)
int chan;
unsigned char synth,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10;
{
	int offs;

	outdata(synth,0xa0+chan,0);
	outdata(synth,0xb0+chan,0);
	outdata(synth,0xc0+chan,v10);
	offs = adlibchanoffs[chan];
	outdata(synth,0x20+offs,v5);
	outdata(synth,0x40+offs,v6);
	outdata(synth,0x60+offs,v7);
	outdata(synth,0x80+offs,v8);
	outdata(synth,0xe0+offs,v9);
	offs+=3;
	outdata(synth,0x20+offs,v0);
	outdata(synth,0x40+offs,v1);
	outdata(synth,0x60+offs,v2);
	outdata(synth,0x80+offs,v3);
	outdata(synth,0xe0+offs,v4);
}

outdata(synth,index,data)
unsigned char synth,index,data;
{
	if (synth == 1)
		_asm mov dx, 0x38a ; get the right 3812 address
	else
		_asm mov dx, 0x388 ; get the left 3812 address
	_asm \
	{
		mov ax, index    ; get the index value
		out dx, al       ; output to both chips
		in al, dx        ; slow down for the index to settle
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		inc dx           ; move to the data register
		mov ax, data
		out dx, al       ; write the data out
		mov cx, 33       ; load the loop count
 lbl1:in al, dx
		loop lbl1
	}
}

drumstatus(status)
int status;
{
	char instbu2[11];
	int i;

	if (status == 0)
	{
		drumstat = 0;
		numchans = 9;
		outdata(0,0xbd,drumstat);
	}
	if (status == 1)
	{
		for(i=0;i<11;i++)
			instbu2[i] = inst[trinst[11]][i+21];
		instbu2[1] = ((instbu2[1]&192)|(trvol[11])^63);
		setinst(0,6,instbu2[0],instbu2[1],instbu2[2],instbu2[3],instbu2[4],instbu2[5],instbu2[6],instbu2[7],instbu2[8],instbu2[9],instbu2[10]);
		for(i=0;i<5;i++)
			instbu2[i] = inst[trinst[12]][i+21];
		for(i=5;i<11;i++)
			instbu2[i] = inst[trinst[15]][i+21];
		instbu2[1] = ((instbu2[1]&192)|(trvol[12])^63);
		instbu2[6] = ((instbu2[6]&192)|(trvol[15])^63);
		setinst(0,7,instbu2[0],instbu2[1],instbu2[2],instbu2[3],instbu2[4],instbu2[5],instbu2[6],instbu2[7],instbu2[8],instbu2[9],instbu2[10]);
		for(i=0;i<5;i++)
			instbu2[i] = inst[trinst[14]][i+21];
		for(i=5;i<11;i++)
			instbu2[i] = inst[trinst[13]][i+21];
		instbu2[1] = ((instbu2[1]&192)|(trvol[14])^63);
		instbu2[6] = ((instbu2[6]&192)|(trvol[13])^63);
		setinst(0,8,instbu2[0],instbu2[1],instbu2[2],instbu2[3],instbu2[4],instbu2[5],instbu2[6],instbu2[7],instbu2[8],instbu2[9],instbu2[10]);
		outdata(0,0xa0+6,600&255);
		outdata(0,0xb0+6,(600>>8)&223);
		outdata(0,0xa0+7,400&255);
		outdata(0,0xb0+7,(400>>8)&223);
		outdata(0,0xa0+8,5510&255);
		outdata(0,0xb0+8,(5510>>8)&223);
		drumstat = 32;
		numchans = 6;
		outdata(0,0xbd,drumstat);
	}
}

mouse(x,y,b)
int *x,*y,*b;
{
	union REGS Regs;

	Regs.x.ax = 11; int86(0x33,&Regs,&Regs);
	*x = Regs.x.cx;
	*y = Regs.x.dx;
	Regs.x.ax = 5;
	int86(0x33,&Regs,&Regs); *b = Regs.x.ax;
}

setupmouse()
{
	unsigned long address;
	unsigned char first_byte;

	union REGS inregs, outregs;
	struct SREGS segregs;

	inregs.x.ax = 0x3533;
	intdosx(&inregs,&outregs,&segregs);
	address = (((long) segregs.es) << 16) + (long) outregs.x.bx;
	first_byte = (unsigned char) * (long far *)address;
	if ((address == 0L) || (first_byte == 0xcf))
		return(1);
	else
	{
		inregs.x.ax = 0; int86(0x33,&inregs,&outregs);
		return(0);
	}
}

deletenote(notenum)
int notenum;
{
	int i;

	if ((notenum >= 0) && (notenum < numnotes))
	{
		numnotes--;
		for(i=notenum;i<numnotes;i++)
			note[i] = note[i+1];
	}
}

sortnotearray()
{
	int i, j;
	unsigned long tempnote;

	outext(24,33,11+128,"Sorting data...");
	for(i=1;i<numnotes;i++)
		for(j=0;j<i;j++)
			if (note[i] < note[j])
			{
				tempnote = note[i];
				note[i] = note[j];
				note[j] = tempnote;
			}
	outext(24,33,6,"               ");
}

recordtrack(track,saveit)
int track, saveit;
{
	char ch;
	int i, j, k, dat, lastat, lastnumnotes, status;
	unsigned long templong, temp, quanter;

	for(i=0;i<numchans;i++)
	{
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	j = 0;
	for(i=0;i<11;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0))
			{
				chantrack[j] = i;
				k--;
				j++;
			}
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++)
			instbuf[j] = inst[trinst[chantrack[i]]][j+21];
		instbuf[1] = (instbuf[1]&192)|(trvol[chantrack[i]]^63);
		setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
	}
	drumstatus(trchan[11]);
	k = 0;
	click = 0;
	clicknum = 0;
	clickstat = 0;
	lastat = 0x90;
	count = 0;
	lastnumnotes = numnotes;
	ch = 0;
	startcount(speed);
	while (ch == 0)
	{
		quanter = (240/trquant[(char)((note[k]>>8)&15)]);
		templong = (((note[k]>>12)+(quanter>>1)) / quanter) * quanter;
		while ((count < templong) && (ch == 0))
		{
			while ((dat=getdata()) != -1)
			{
				if ((dat >= 0x80) && (dat != 0xfe))
					lastat = dat;
				if ((dat >= 0x00) && (dat < 0x80) && (lastat == 0x90))
				{
					status = getdata();
					adlib(templong,(int)track,(int)status,(int)(dat-35));
					if (saveit == 1)
						if ((track < 11) || ((track >= 11) && ((drumstat&32) > 0) && (status > 0)))
						{
							if (status > 0)
								status = 1;
							note[numnotes] = (long)(dat-35)+(long)(status<<6)+((long)track<<8)+(count<<12);
							numnotes++;
						}
				}
			}
			if (kbhit() != 0)
				ch = getch();
		}
		if (k < lastnumnotes)
			adlib(templong,(int)((note[k]>>8)&15),(int)((note[k]>>6)&3),(int)(note[k]&63));
		k++;
	}
	stopcount();
	outp(97,inp(97)&252);
	outp(0x3c8,0);
	outp(0x3c9,0);
	outp(0x3c9,0);
	outp(0x3c9,0);
	for(i=0;i<numchans;i++)
	{
		outdata(0,0xa0+i,adlibfreq[chanfreq[i]]&255);
		outdata(0,0xb0+i,(adlibfreq[chanfreq[i]]>>8)&223);
	}
	drumstat&=32;
	outdata(0,0xbd,drumstat);
	ch = 0;
	if (saveit == 1)
		sortnotearray();
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	outp(0x3d4,0xa); outp(0x3d5,inp(0x3d5) | 0x0f);
	outp(0x3d4,0xb); outp(0x3d5,inp(0x3d5) & 0xf0);
}

play(countostart)
unsigned long countostart;
{
	char ch;
	int i, j, k, track;
	unsigned long templong, temp, quanter;

	for(i=0;i<numchans;i++)
	{
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	j = 0;
	for(i=0;i<11;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0))
			{
				chantrack[j] = i;
				k--;
				j++;
			}
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++)
			instbuf[j] = inst[trinst[chantrack[i]]][j+21];
		instbuf[1] = (instbuf[1]&192)|(trvol[chantrack[i]]^63);
		setinst(0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
	}
	drumstatus(trchan[11]);
	click = 0;
	clicknum = 0;
	clickstat = -1;
	k = 0;
	quanter = (240/trquant[0]);
	countostart = ((countostart+(quanter>>1)) / quanter) * quanter;
	count = countostart;
	templong = (((note[k]>>12)+(quanter>>1)) / quanter) * quanter;
	while ((templong < countostart) && (k < numnotes-1))
	{
		k++;
		templong = (((note[k]>>12)+(quanter>>1)) / quanter) * quanter;
	}
	k--;
	if (k < 0)
		k = 0;
	startcount(speed);
	ch = 0;
	while ((k < numnotes) && (ch == 0))
	{
		quanter = (240/trquant[(char)((note[k]>>8)&15)]);
		templong = (((note[k]>>12)+(quanter>>1)) / quanter) * quanter;
		track = (int)((note[k]>>8)&15);
		while((count < templong) && (ch == 0))
		{
			if (kbhit() != 0)
				ch = getch();
		}
		adlib(templong,(int)track,(int)((note[k]>>6)&3),(int)(note[k]&63));
		k++;
	}
	stopcount();
	for(i=0;i<numchans;i++)
	{
		outdata(0,0xa0+i,adlibfreq[chanfreq[i]]&255);
		outdata(0,0xb0+i,(adlibfreq[chanfreq[i]]>>8)&223);
	}
	drumstat&=32;
	outdata(0,0xbd,drumstat);
	ch = 0;
}

loadsong(filename)
char filename[80];
{
	int infile, i;

	filename = strupr(filename);
	if (strstr(filename,".KSM") == 0)
		strcat(filename,".KSM");
	if((infile=open(filename,O_BINARY|O_RDONLY,S_IREAD))==-1)
	{
		printf("I cannot load %s.",filename);
		exit(0);
	}
	read(infile,&trinst[0],16);
	read(infile,&trquant[0],16);
	read(infile,&trchan[0],16);
	read(infile,&trfut[0],16);
	read(infile,&trvol[0],16);
	read(infile,&numnotes,2);
	read(infile,&note[0],(unsigned)(numnotes<<2));
	close(infile);
	for(i=numnotes;i<8192;i++)
		note[i] = 0;
	drumstatus(trchan[11]);
}

savesong(filename)
char filename[80];
{
	int infile;

	filename = strupr(filename);
	if (strstr(filename,".KSM") == 0)
		strcat(filename,".KSM");
	if((infile=open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE))==-1)
	{
		printf("I cannot save %s.",filename);
		exit(0);
	}
	write(infile,&trinst[0],16);
	write(infile,&trquant[0],16);
	write(infile,&trchan[0],16);
	write(infile,&trfut[0],16);
	write(infile,&trvol[0],16);
	write(infile,&numnotes,2);
	write(infile,&note[0],(unsigned)(numnotes<<2));
	close(infile);
}

getfilename(filename)
char filename[80];
{
	int i;
	char ch, buffer[3];

	outext(13,35,6,"            ");
	i = 0;
	ch = 0;
	while (ch != 13)
	{
		ch = getch();
		if (ch == 0)
		{
			ch = getch();
			ch = 0;
		}
		if ((ch == 8) && (i > 0))
		{
			filename[i] = 0;
			i--;
			outext(13,35+i,6," ");
		}
		if ((ch != 13) && (ch != 8) && (i < 12))
		{
			filename[i] = ch;
			buffer[0] = ch;
			buffer[1] = 0;
			outext(13,35+i,6,buffer);
			i++;
		}
	}
	filename[i] = 0;
}

getdir()
{
	struct find_t fileinfo;
	int i;
	char tempbuf[80];

	numfiles = 0;
	if (_dos_findfirst("*.ksm",_A_NORMAL,&fileinfo) == 0)
	{
		strcpy(filelist[0],fileinfo.name);
		numfiles++;
		while (_dos_findnext(&fileinfo) == 0)
		{
			strcpy(filelist[numfiles],fileinfo.name);
			for(i=0;i<numfiles;i++)
				if(strcmp(filelist[numfiles],filelist[i]) < 0)
				{
					strcpy(tempbuf,filelist[numfiles]);
					strcpy(filelist[numfiles],filelist[i]);
					strcpy(filelist[i],tempbuf);
				}
			numfiles++;
		}
	}
}
