//KSMWIN.C by Ken Silverman (http://advsys.net/ken)
#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define log2(a) (log(a)/log(2))

long samplerate, numspeakers, bytespersample;

extern float lvol[9], rvol[9];
extern long lplc[9], rplc[9];
void adlibinit(long samplerate, long numspeakers, long bytespersample);
void adlib0(long index, long value);
void adlibgetsample(void *sndptr, long numsamples);

static unsigned long calccycles = 1, freecycles = 1;
static long t0, t1;

unsigned long note[8192], musicstatus, count, countstop;
unsigned int nownote, numnotes, speed, numchans, firstime = 1;
static unsigned int drumstat;
static unsigned long chanage[18];
static unsigned char inst[256][11], chanfreq[18], chantrack[18];
static unsigned char trinst[16], trquant[16], trchan[16], trprio[16];
static unsigned char trvol[16], adlibchanoffs[9] = {0,1,2,8,9,10,16,17,18};
static unsigned int adlibfreq[63] =
{
	0,
	2390,2411,2434,2456,2480,2506,2533,2562,2592,2625,2659,2695,
	3414,3435,3458,3480,3504,3530,3557,3586,3616,3649,3683,3719,
	4438,4459,4482,4504,4528,4554,4581,4610,4640,4673,4707,4743,
	5462,5483,5506,5528,5552,5578,5605,5634,5664,5697,5731,5767,
	6486,6507,6530,6552,6576,6602,6629,6658,6688,6721,6755,6791,
	7510
};

	//Global window variables
HWND ghwnd;
HINSTANCE ghinst, ghpinst;
LPSTR gcmdline;
int gncmdshow;

char displaybuf[256];
char *programname = "KSMwin", curfilename[256];
static char keystatus[256];
OPENFILENAME ofn;

setinst (int chan, char *v)
{
	adlib0(chan+0xa0,0);
	adlib0(chan+0xb0,0);
	adlib0(chan+0xc0,v[10]);
	chan = adlibchanoffs[chan];
	adlib0(chan+0x20,v[5]);
	adlib0(chan+0x40,v[6]);
	adlib0(chan+0x60,v[7]);
	adlib0(chan+0x80,v[8]);
	adlib0(chan+0xe0,v[9]);
	adlib0(chan+0x23,v[0]);
	adlib0(chan+0x43,v[1]);
	adlib0(chan+0x63,v[2]);
	adlib0(chan+0x83,v[3]);
	adlib0(chan+0xe3,v[4]);
}

long loadmusic(char *filename)
{
	char buffer[256], instbuf[11];
	int infile, i, j;

	if (firstime == 1)
	{
		if ((infile = open("insts.dat",O_BINARY|O_RDONLY,S_IREAD)) == -1)
			return(-1); //{ printf("I cannot load insts.dat!"); exit(0); }
		for(i=0;i<256;i++)
		{
			read(infile,buffer,33);
			for(j=0;j<11;j++) inst[i][j] = buffer[j+20];
		}
		close(infile);
		numchans = 9;
		adlib0(0x1,32);  //clear test stuff
		adlib0(0x4,0);   //reset
		adlib0(0x8,0);   //2-operator synthesis
		firstime = 0;
	}
	strcpy(buffer,filename);
	if ((!strstr(buffer,".KSM")) && (!strstr(buffer,".ksm"))) strcat(buffer,".KSM");
	if ((infile = open(buffer,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1); //{ printf("I cannot load %s.",filename); exit(0); }
	read(infile,trinst,16);
	read(infile,trquant,16);
	read(infile,trchan,16);
	read(infile,trprio,16);
	read(infile,trvol,16);
	read(infile,&numnotes,2);
	read(infile,note,numnotes<<2);
	close(infile);
	if (!trchan[11]) { drumstat = 0; numchans = 9; adlib0(0xbd,drumstat); }
	if (trchan[11] == 1)
	{
		for(i=0;i<11;i++) instbuf[i] = inst[trinst[11]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[11])^63);
		setinst(6,instbuf);
		for(i=0;i<5;i++) instbuf[i] = inst[trinst[12]][i];
		for(i=5;i<11;i++) instbuf[i] = inst[trinst[15]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[12])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[15])^63);
		setinst(7,instbuf);
		for(i=0;i<5;i++) instbuf[i] = inst[trinst[14]][i];
		for(i=5;i<11;i++) instbuf[i] = inst[trinst[13]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[14])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[13])^63);
		setinst(8,instbuf);
		drumstat = 32; numchans = 6; adlib0(0xbd,drumstat);
	}
	return(0);
}

musicon()
{
	long i, j, k;
	char instbuf[11];

	for(i=0;i<numchans;i++) chantrack[i] = chanage[i] = 0;
	j = 0;
	for(i=0;i<16;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0)) { chantrack[j] = i; k--; j++; }
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++) instbuf[j] = inst[trinst[chantrack[i]]][j];
		instbuf[1] = ((instbuf[1]&192)|(trvol[chantrack[i]]^63));
		setinst(i,instbuf);
		chanfreq[i] = 0;
	}
	count = countstop = (note[0]>>12)-1;
	nownote = 0; musicstatus = 1;
}

musicoff()
{
	int i;

	for(i=0;i<numchans;i++) { adlib0(0xa0+i,0); adlib0(0xb0+i,0); }
	musicstatus = 0;
}

ksmnexttic()
{
	long i, j, k, track, volevel, templong;

	count++;
	while (count >= countstop)
	{
		templong = note[nownote]; track = ((templong>>8)&15);
		if (!(templong&192))
		{
			i = 0;
			while (((chanfreq[i] != (templong&63)) || (chantrack[i] != ((templong>>8)&15))) && (i < numchans))
				i++;
			if (i < numchans)
			{
				adlib0(i+0xb0,(adlibfreq[templong&63]>>8)&0xdf);
				chanfreq[i] = chanage[i] = 0;
			}
		}
		else
		{
			volevel = trvol[track]^63;
			if ((templong&192) == 128) volevel = min(volevel+4,63);
			if ((templong&192) == 192) volevel = max(volevel-4,0);
			if (track < 11)
			{
				i = numchans; k = 0;
				for(j=0;j<numchans;j++)
					if ((countstop-chanage[j] >= k) && (chantrack[j] == track))
						{ k = countstop-chanage[j]; i = j; }
				if (i < numchans)
				{
					adlib0(i+0xb0,0);
					adlib0(adlibchanoffs[i]+0x43,(inst[trinst[track]][1]&192)+volevel);
					adlib0(i+0xa0,adlibfreq[templong&63]);
					adlib0(i+0xb0,(adlibfreq[templong&63]>>8)|32);
					chanfreq[i] = templong&63; chanage[i] = countstop;
				}
			}
			else if (drumstat&32)
			{
				j = adlibfreq[templong&63];
				switch(track)
				{
					case 11: i = 6; j -= 2048; break;
					case 12: case 15: i = 7; j -= 2048; break;
					case 13: case 14: i = 8; break;
				}
				adlib0(i+0xa0,j);
				adlib0(i+0xb0,(j>>8)&0xdf);
				adlib0(0xbd,drumstat&(~(32768>>track)));
				if ((track == 11) || (track == 12) || (track == 14))
					adlib0(adlibchanoffs[i]+0x43,(inst[trinst[track]][1]&192)+volevel);
				else
					adlib0(adlibchanoffs[i]+0x40,(inst[trinst[track]][6]&192)+volevel);
				drumstat |= (32768>>track);
				adlib0(0xbd,drumstat);
			}
		}
		nownote++; if (nownote >= numnotes) nownote = 0;
		templong = note[nownote];
		if (!nownote) count = (templong>>12)-1;
		i = 240 / trquant[(templong>>8)&15];
		countstop = (templong>>12)+(i>>1); countstop -= countstop%i;
	}
}

static long minicnt = 0;
preparesound(void *dasnd, long numbytestoprocess)
{
	long i, prepcnt;

	prepcnt = numbytestoprocess;
	while (prepcnt > 0)
	{
		i = min(prepcnt,(minicnt/speed+4)&~3);
		adlibgetsample(dasnd,i);
		dasnd = (void *)(((long)dasnd)+i);
		prepcnt -= i;

		minicnt -= speed*i;
		while (minicnt < 0)
		{
			minicnt += samplerate*numspeakers*bytespersample;
			ksmnexttic();
		}
	}
}


randoinsts()
{
	long i, j, k;
	float f;

	if (numspeakers == 2)
	{
		j = (rand()&2)-1; k = 0;
		for(i=0;i<9;i++)
		{
			if ((i == 0) || (chantrack[i] != chantrack[i-1]))
			{
				f = (float)rand()/32768.0;
				if (j > 0)
				{
						//lvol[i] < rvol[i]
					lvol[i] = log2(f+1);
					rvol[i] = log2(3-f);
					lplc[i] = rand()&255;
					rplc[i] = 0;
				}
				else
				{
						//lvol[i] > rvol[i]
					lvol[i] = log2(3-f);
					rvol[i] = log2(f+1);
					lplc[i] = 0;
					rplc[i] = rand()&255;
				}
				j = -j;
				if (((drumstat&32) == 0) || (i < 6)) k++;
			}
			else
			{
				lvol[i] = lvol[i-1]; rvol[i] = rvol[i-1];
				lplc[i] = lplc[i-1]; rplc[i] = rplc[i-1];
			}
		}
		if (k < 2)  //If only 1 source, force it to be in center
		{
			if (drumstat&32) i = 5; else i = 8;
			for(;i>=0;i--)
			{
				lvol[i] = rvol[i] = 1;
				lplc[i] = rplc[i] = 0;
			}
		}
	}
}

//MultiMedia Sound Data & Code begins-------------------------------------
#define SOUNDBUFFERS 4
HWAVEOUT WaveOut;
WAVEHDR WaveOutHdr[SOUNDBUFFERS];
HGLOBAL hsoundbuf[SOUNDBUFFERS];
void *soundbuf[SOUNDBUFFERS];
long soundbufdoneflag = 0x80000000, soundbufside = 0, bufleng = 0;

initsound(long dasamplerate, long danumspeakers, long dabytespersample)
{
	WAVEOUTCAPS WaveOutCaps;
	PCMWAVEFORMAT mywaveformat;
	char tempbuf[256], tempbuf2[256];
	MMRESULT m;
	long i;

	samplerate = dasamplerate; numspeakers = danumspeakers; bytespersample = dabytespersample;
		//dwFormats:
		//WAVE_FORMAT_1M08:D0,WAVE_FORMAT_1S08:D1,WAVE_FORMAT_1M16:D2,WAVE_FORMAT_1S16:D3
		//WAVE_FORMAT_2M08:D4,WAVE_FORMAT_2S08:D5,WAVE_FORMAT_2M16:D6,WAVE_FORMAT_2S16:D7
		//WAVE_FORMAT_4M08:D8,WAVE_FORMAT_4S08:D9,WAVE_FORMAT_4M16:D10,WAVE_FORMAT_4S16:D11
	waveOutGetDevCaps(0,&WaveOutCaps,sizeof(WaveOutCaps));
	if (!(WaveOutCaps.dwFormats&0xaaa)) numspeakers = 1;
	if (!(WaveOutCaps.dwFormats&0xccc)) bytespersample = 1;
	if (!(WaveOutCaps.dwFormats&0xf00)) samplerate = 22050;
	if (!(WaveOutCaps.dwFormats&0xff0)) samplerate = 11025;

	mywaveformat.wf.wFormatTag = WAVE_FORMAT_PCM;
	mywaveformat.wf.nChannels = numspeakers;
	mywaveformat.wf.nSamplesPerSec = samplerate;
	mywaveformat.wf.nAvgBytesPerSec = samplerate*numspeakers*bytespersample;
	mywaveformat.wf.nBlockAlign = numspeakers*bytespersample;
	mywaveformat.wBitsPerSample = (bytespersample<<3);
	if ((m = waveOutOpen(&WaveOut,WAVE_MAPPER,(void *)&mywaveformat,(long)ghwnd,0L,WAVE_ALLOWSYNC|CALLBACK_WINDOW)) != 0)
	{
		waveOutGetErrorText(m,tempbuf2,256);
		sprintf(tempbuf,"%s",tempbuf2);
		MessageBox(0,tempbuf,"Tough luck",MB_OK);
		return(-1);
	}

	bufleng = samplerate-(samplerate%(bytespersample*numspeakers));

	for(i=0;i<SOUNDBUFFERS;i++)
	{
		hsoundbuf[i] = GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,bufleng);
		soundbuf[i] = (void *)GlobalLock(hsoundbuf[i]);

		WaveOutHdr[i].lpData = soundbuf[i];
		WaveOutHdr[i].dwBufferLength = bufleng;
		WaveOutHdr[i].dwBytesRecorded = 0;
		WaveOutHdr[i].dwUser = 0;
		WaveOutHdr[i].dwFlags = 0; //WHDR_BEGINLOOP|WHDR_ENDLOOP?;
		WaveOutHdr[i].dwLoops = 1;
		waveOutPrepareHeader(WaveOut,&WaveOutHdr[i],sizeof(WAVEHDR));
	}

	soundbufdoneflag = SOUNDBUFFERS;
	return(0);
}

uninitsound()
{
	long i;

	waveOutReset(WaveOut);
	waveOutClose(WaveOut);

	for(i=0;i<SOUNDBUFFERS;i++)
	{
		waveOutUnprepareHeader(WaveOut,&WaveOutHdr[i],sizeof(WAVEHDR));
		GlobalFree(hsoundbuf[i]);
	}
	soundbufdoneflag = 0x80000000;
}

soundbreath()
{
	long i;

	while (soundbufdoneflag > 0)
	{
		soundbufdoneflag--;
		i = (soundbufside%SOUNDBUFFERS);
		preparesound(soundbuf[i],bufleng);
		waveOutWrite(WaveOut,&WaveOutHdr[i],sizeof(WAVEHDR));
		soundbufside++;
	}
}
//MultiMedia Sound Data & Code ends --------------------------------------


LONG FAR PASCAL Handlers(HWND hwnd,unsigned msg,UINT wparam,LONG lparam)
{
	PAINTSTRUCT ps;
	HDC hDC;
	RECT rect;

	switch(msg)
	{
		case WM_PAINT:
			hDC = BeginPaint(hwnd,&ps);
			SetTextAlign(hDC,TA_CENTER);
			SetBkColor(hDC,0x808080);
			 GetClientRect(ghwnd,&rect);
			TextOut(hDC,(rect.left+rect.right)>>1,rect.top,displaybuf,strlen(displaybuf));
			 EndPaint(hwnd,&ps);
			break;
		case WM_KEYDOWN: keystatus[((lparam>>16)&127)+((lparam>>17)&128)] = 1; break;
		case WM_KEYUP: keystatus[((lparam>>16)&127)+((lparam>>17)&128)] = 0; break;
		case MM_WOM_DONE:
			soundbufdoneflag++;
			soundbreath();  //This makes playback work during opening files
			break;
		case WM_DESTROY:
			musicoff();
			uninitsound();
			PostQuitMessage(0);
			break;
		default: return(DefWindowProc(hwnd,msg,wparam,lparam));
	}
	return(0);
}

int PASCAL WinMain(HINSTANCE hinst, HINSTANCE hpinst, LPSTR cmdline, int ncmdshow)
{
	WNDCLASS wc;
	MSG msg;
	HDC hDC;
	long i, argc;
	char *argv[64], tempbuf[256];

	ghinst = hinst; ghpinst = hpinst; gcmdline = cmdline; gncmdshow = ncmdshow;

	argv[0] = programname; argc = 1;
	if (cmdline[0] != 0)
	{
		if ((cmdline[0] != ' ') && (cmdline[0] != 9)) argv[argc++] = cmdline;
		for (i=1;cmdline[i];i++)
		{
			if ((cmdline[i-1] != ' ') && (cmdline[i-1] != 9)) continue;
			cmdline[i-1] = 0;
			if ((cmdline[i] != ' ') && (cmdline[i] != 9)) argv[argc++] = &cmdline[i];
		}
	}

	if (argc != 2)
	{
		curfilename[0] = 0;
		tempbuf[0] = 0;

		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = NULL; //ghwnd;
		ofn.hInstance = ghinst;
		ofn.lpstrFilter = "Ken'S Music file (*.KSM)\0*.ksm\0";
		ofn.lpstrDefExt = "ksm";
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = tempbuf; ofn.nMaxFile = sizeof(tempbuf);
		ofn.lpstrFileTitle = curfilename; ofn.nMaxFileTitle = sizeof(curfilename);
		ofn.lpstrInitialDir = NULL; //NULL means use current directory
		ofn.lpstrTitle = "Open KSM file";
		ofn.Flags = OFN_SHOWHELP|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT; //OFN_NOCHANGEDIR
		if (!GetOpenFileName(&ofn))
		//   strcpy(curfilename,ofn.lpstrFile);
		//else
		{
			MessageBox(0,"Please specify a filename",programname,MB_OK);
			return(1);
		}
	}
	else
	{
			//Chop off quotes at beginning and end of filename
		for(i=strlen(argv[1]);i>0;i--)
			if (argv[1][i-1] == '\\')
				break;
		i = max(i,(argv[1][0] == '\"'));
		strcpy(curfilename,&argv[1][i]);
		if (curfilename[0] == 0) return(-1);
		if (curfilename[strlen(curfilename)-1] == '\"') curfilename[strlen(curfilename)-1] = 0;
		strlwr(curfilename);
		if (!strstr(curfilename,".ksm")) strcat(curfilename,".ksm");
	}

	if (ghwnd = FindWindow(programname,programname)) SendMessage(ghwnd,WM_DESTROY,0,0);

	if (!hpinst)
	{
		wc.style = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc = (LPVOID)Handlers;
		wc.cbClsExtra = 0; wc.cbWndExtra = 0;
		wc.hInstance = ghinst;
		wc.hIcon = LoadIcon(0,IDI_APPLICATION);
		wc.hCursor = LoadCursor(0,IDC_ARROW);
		wc.hbrBackground = GetStockObject(BLACK_BRUSH);
		wc.lpszMenuName = "      KensMenu"; wc.lpszClassName = programname;
		if (!RegisterClass(&wc)) return(0);
	}
	hDC = GetDC(0);
	i = GetDeviceCaps(hDC,VERTRES);
	ReleaseDC(0,hDC);
	if (!(ghwnd = CreateWindow(programname,programname,WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,(GetSystemMetrics(SM_CXSCREEN)-248)>>1,i-68,248,38,0,0,ghinst,0)))
		return(0);

	ShowWindow(ghwnd,SW_SHOWMINNOACTIVE); //gncmdshow);

	numspeakers = 2; bytespersample = 2;
	if (initsound(44100,numspeakers,bytespersample) < 0) return(1);
	adlibinit(samplerate,numspeakers,bytespersample);

	speed = 240;
	//if (argc > 2) speed = min(max(atoi(argv[2]),60),960);
	loadmusic(curfilename); //argv[1]);
	musicon();
	sprintf(displaybuf,"%s, %5ldhz, Speed:%ld",curfilename,samplerate,speed);

	srand(0); randoinsts();
	
	UpdateWindow(ghwnd);

	while (1)
	{
		while (PeekMessage(&msg,0,0,0,PM_REMOVE))
		{
			if (msg.message == WM_QUIT) return(msg.wParam);
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (keystatus[1]) PostMessage(ghwnd,WM_CLOSE,0,0);
		if (keystatus[0x39]) { keystatus[0x39] = 0; randoinsts(); }
		if (keystatus[0x33])  // <,
		{
			keystatus[0x33] = 0;
			i = speed;
			speed = max(((speed*7)>>3),60);
			if ((i > 240) && (speed < 240)) speed = 240;
			sprintf(displaybuf,"%s, %5ldhz, Speed:%ld",curfilename,samplerate,speed);
			InvalidateRect(ghwnd,0,1);
		}
		if (keystatus[0x34])  // >.
		{
			keystatus[0x34] = 0;
			i = speed;
			speed = min(((speed*9)>>3),960);
			if ((i < 240) && (speed > 240)) speed = 240;
			sprintf(displaybuf,"%s, %5ldhz, Speed:%ld",curfilename,samplerate,speed);
			InvalidateRect(ghwnd,0,1);
		}
		if (keystatus[0x26]) //L
		{
			keystatus[0x26] = 0;
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = ghwnd;
			ofn.hInstance = ghinst;
			ofn.lpstrFilter = "Ken'S Music file (*.KSM)\0*.ksm\0";
			ofn.lpstrDefExt = "ksm";
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = curfilename; ofn.nMaxFile = sizeof(curfilename);
			ofn.lpstrFileTitle = tempbuf; ofn.nMaxFileTitle = sizeof(tempbuf);
			ofn.lpstrInitialDir = NULL; //NULL means use current directory
			ofn.lpstrTitle = "Open KSM file";
			ofn.Flags = OFN_SHOWHELP|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT; //OFN_NOCHANGEDIR
			if (GetOpenFileName(&ofn))
			{
				musicoff();
				if (loadmusic(ofn.lpstrFile) < 0)
				{
					sprintf(tempbuf,"File not found (%s)",ofn.lpstrFile);
					MessageBox(0,tempbuf,programname,MB_OK);

					musicon();
				}
				else
				{
					strcpy(curfilename,tempbuf);

					sprintf(displaybuf,"%s, %5ldhz, Speed:%ld",curfilename,samplerate,speed);
					InvalidateRect(ghwnd,0,1);

					musicon();
					srand(0); randoinsts();
				}
			}
		}
		soundbreath();
	}
}
