//PLAYKSM.C by Ken Silverman (http://advsys.net/ken)
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>

unsigned long musicstatus, count, countstop;
unsigned int nownote, numnotes, speed, numchans, firstime = 1;
static unsigned int note, drumstat;
static unsigned long chanage[18];
static unsigned char inst[256][11], databuf[2048];
static unsigned char chanfreq[18], chantrack[18];
static unsigned char trinst[16], trquant[16], trchan[16];
static unsigned char trprio[16];
static unsigned char trvol[16], adlibchanoffs[9] = {0,1,2,8,9,10,16,17,18};
static unsigned int adlibfreq[63] =
{
	0,
	2390,2411,2434,2456,2480,2506,2533,2562,2592,2625,2659,2695,
	3414,3435,3458,3480,3504,3530,3557,3586,3616,3649,3683,3719,
	4438,4459,4482,4504,4528,4554,4581,4610,4640,4673,4707,4743,
	5462,5483,5506,5528,5552,5578,5605,5634,5664,5697,5731,5767,
	6486,6507,6530,6552,6576,6602,6629,6658,6688,6721,6755,6791,
	7510
};
void interrupt far ksmhandler(void);
void (interrupt far *oldhand)();

main(int argc,char **argv)
{
	int i;

	if ((argc < 2) || (argc > 3))
	{
		printf("Playksm [filename][speed(240)]                             by Kenneth Silverman\n");
		exit(0);
	}
	speed = 240;
	if (argc > 2)
	{
		speed = atoi(argv[2]);
		if (speed < 60)
			speed = 60;
		if (speed > 960)
			speed = 960;
	}
	if ((note = convallocate(8192>>4)) == -1)
	{
		printf("Allocation failed!");
		exit(-1);
	}
	loadmusic(argv[1]);
	musicon();
	printf("Playing %s, Press any key to exit...\n",argv[1]);
	getch();
	musicoff();
	convdeallocate(note);
}

loadmusic(filename)
char filename[80];
{
	char buffer[256], instbuf[11];
	int infile, i, j;

	if (firstime == 1)
	{
		if((infile=open("insts.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		{
			printf("I cannot load insts.dat!");
			exit(0);
		}
		for(i=0;i<256;i++)
		{
			read(infile,&buffer[0],33);
			for(j=0;j<11;j++)
				inst[i][j] = buffer[j+20];
		}
		close(infile);
		numchans = 9;
		outdata(0,0x1,32);  //clear test stuff
		outdata(0,0x4,0);   //reset
		outdata(0,0x8,0);   //2-operator synthesis
		firstime = 0;
	}
	if ((strstr(filename,".KSM") == 0) && (strstr(filename,".ksm") == 0))
		strcat(filename,".KSM");
	if((infile=open(filename,O_BINARY|O_RDONLY,S_IREAD))==-1)
	{
		printf("I cannot load %s.",filename);
		exit(0);
	}
	read(infile,&trinst[0],16);
	read(infile,&trquant[0],16);
	read(infile,&trchan[0],16);
	read(infile,&trprio[0],16);
	read(infile,&trvol[0],16);
	read(infile,&numnotes,2);
	_asm \
	{
		mov ah, 0x3f
		mov bx, infile
		mov cx, numnotes
		shl cx, 1
		shl cx, 1
		mov dx, 0
		push ds
		mov ds, note
		int 0x21
		pop ds
	}
	close(infile);
	if (trchan[11] == 0)
	{
		drumstat = 0;
		numchans = 9;
		outdata(0,0xbd,drumstat);
	}
	if (trchan[11] == 1)
	{
		for(i=0;i<11;i++)
			instbuf[i] = inst[trinst[11]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[11])^63);
		setinst((char)0,6,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[12]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[15]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[12])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[15])^63);
		setinst((char)0,7,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[14]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[13]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[14])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[13])^63);
		setinst((char)0,8,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		drumstat = 32;
		numchans = 6;
		outdata(0,0xbd,drumstat);
	}
}

outdata(synth,index,data)
unsigned char synth,index,data;
{
	_asm \
	{
		mov dx, 0x388              ; Calculate port address
		mov al, synth
		add dl, al
		add dl, al
		mov al, index              ; get the index value
		out dx, al                 ; output to both chips
		in al, dx                  ; slow down for the index to settle
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		inc dx                     ; move to the data register
		mov al, data
		out dx, al                 ; write the data out
		mov cx, 33                 ; load the loop count
lbl1: in al, dx
		loop lbl1
	}
}

musicon()
{
	char ch;
	unsigned int num;
	int i, j, k, offs;
	unsigned char instbuf[11];
	unsigned long templong;

	for(i=0;i<numchans;i++)
	{
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	j = 0;
	for(i=0;i<16;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0))
			{
				chantrack[j] = i;
				k--;
				j++;
			}
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++)
			instbuf[j] = inst[trinst[chantrack[i]]][j];
		instbuf[1] = ((instbuf[1]&192)|(63-trvol[chantrack[i]]));
		setinst((char)0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
	}
	k = 0;
	musicstatus = 0;
	_asm \
	{
		push es
		mov es, note
		mov ax, word ptr es:[0]
		mov dx, word ptr es:[2]
		mov word ptr templong[0], ax
		mov word ptr templong[2], dx
		pop es
	}
	count = (templong>>12)-1;
	countstop = (templong>>12)-1;
	nownote = 0;
	musicstatus = 1;
	num = (unsigned)(1193182/speed);
	outp(0x43,54); outp(0x40,num&255); outp(0x40,num>>8);
	oldhand = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, ksmhandler); _enable();
}

musicoff()
{
	int i;

	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	_disable(); _dos_setvect(0x8, oldhand); _enable();
	for(i=0;i<numchans;i++)
	{
		outdata(0,0xa0+i,0);
		outdata(0,0xb0+i,0);
	}
	musicstatus = 0;
}

void interrupt far ksmhandler()
{
	int i, j, quanter, bufnum, chan, drumnum, freq;
	int track, volevel, volval;
	unsigned long temp, templong;

	count++;
	if (count >= countstop)
	{
		bufnum = 0;
		while (count >= countstop)
		{
			_asm \
			{
				push es
				mov es, note
				mov di, nownote
				shl di, 1
				shl di, 1
				mov ax, word ptr es:[di]
				mov dx, word ptr es:[di+2]
				mov word ptr templong[0], ax
				mov word ptr templong[2], dx
				pop es
			}
			track = (int)((templong>>8)&15);
			if ((templong&192) == 0)
			{
				i = 0;
				while (((chanfreq[i] != (templong&63)) || (chantrack[i] != ((templong>>8)&15))) && (i < numchans))
					i++;
				if (i < numchans)
				{
					databuf[bufnum] = (char)0, bufnum++;
					databuf[bufnum] = (unsigned char)(0xb0+i); bufnum++;
					databuf[bufnum] = (unsigned char)((adlibfreq[templong&63]>>8)&223); bufnum++;
					chanfreq[i] = 0;
					chanage[i] = 0;
				}
			}
			else
			{
				volevel = trvol[track];
				if ((templong&192) == 128)
				{
					volevel -= 4;
					if (volevel < 0)
						volevel = 0;
				}
				if ((templong&192) == 192)
				{
					volevel += 4;
					if (volevel > 63)
						volevel = 63;
				}
				if (track < 11)
				{
					temp = 0;
					i = numchans;
					for(j=0;j<numchans;j++)
						if ((countstop - chanage[j] >= temp) && (chantrack[j] == track))
						{
							temp = countstop - chanage[j];
							i = j;
						}
					if (i < numchans)
					{
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0xb0+i); bufnum++;
						databuf[bufnum] = (unsigned char)0; bufnum++;
						volval = (inst[trinst[track]][1]&192)+(volevel^63);
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0x40+adlibchanoffs[i]+3); bufnum++;
						databuf[bufnum] = (unsigned char)volval; bufnum++;
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0xa0+i); bufnum++;
						databuf[bufnum] = (unsigned char)(adlibfreq[templong&63]&255); bufnum++;
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0xb0+i); bufnum++;
						databuf[bufnum] = (unsigned char)((adlibfreq[templong&63]>>8)|32); bufnum++;
						chanfreq[i] = templong&63;
						chanage[i] = countstop;
					}
				}
				else if ((drumstat&32) > 0)
				{
					freq = adlibfreq[templong&63];
					switch(track)
					{
						case 11: drumnum = 16; chan = 6; freq -= 2048; break;
						case 12: drumnum = 8; chan = 7; freq -= 2048; break;
						case 13: drumnum = 4; chan = 8; break;
						case 14: drumnum = 2; chan = 8; break;
						case 15: drumnum = 1; chan = 7; freq -= 2048; break;
					}
					databuf[bufnum] = (char)0, bufnum++;
					databuf[bufnum] = (unsigned char)(0xa0+chan); bufnum++;
					databuf[bufnum] = (unsigned char)(freq&255); bufnum++;
					databuf[bufnum] = (char)0, bufnum++;
					databuf[bufnum] = (unsigned char)(0xb0+chan); bufnum++;
					databuf[bufnum] = (unsigned char)((freq>>8)&223); bufnum++;
					databuf[bufnum] = (char)0, bufnum++;
					databuf[bufnum] = (unsigned char)(0xbd); bufnum++;
					databuf[bufnum] = (unsigned char)(drumstat&(255-drumnum)); bufnum++;
					drumstat |= drumnum;
					if ((track == 11) || (track == 12) || (track == 14))
					{
						volval = (inst[trinst[track]][1]&192)+(volevel^63);
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0x40+adlibchanoffs[chan]+3); bufnum++;
						databuf[bufnum] = (unsigned char)(volval); bufnum++;
					}
					else
					{
						volval = (inst[trinst[track]][6]&192)+(volevel^63);
						databuf[bufnum] = (char)0, bufnum++;
						databuf[bufnum] = (unsigned char)(0x40+adlibchanoffs[chan]); bufnum++;
						databuf[bufnum] = (unsigned char)(volval); bufnum++;
					}
					databuf[bufnum] = (char)0, bufnum++;
					databuf[bufnum] = (unsigned char)(0xbd); bufnum++;
					databuf[bufnum] = (unsigned char)(drumstat); bufnum++;
				}
			}
			nownote++;
			if (nownote >= numnotes)
				nownote = 0;
			_asm \
			{
				push es
				mov es, note
				mov di, nownote
				shl di, 1
				shl di, 1
				mov ax, word ptr es:[di]
				mov dx, word ptr es:[di+2]
				mov word ptr templong[0], ax
				mov word ptr templong[2], dx
				pop es
			}
			if (nownote == 0)
				count = (templong>>12)-1;
			quanter = (240/trquant[(templong>>8)&15]);
			countstop = (((templong>>12)+(quanter>>1)) / quanter) * quanter;
		}
		for(i=0;i<bufnum;i+=3)
			_asm \
			{
				mov bx, i
				mov dx, 0x388             ; get the left 3812 address
				mov al, databuf[bx+0]
				add dl, al
				add dl, al
				mov al, databuf[bx+1]     ; get the index value
				out dx, al                ; output to both chips
				in al, dx                 ; slow down for the index to settle
				in al, dx
				in al, dx
				in al, dx
				in al, dx
				inc dx                    ; move to the data register
				mov al, databuf[bx+2]
				out dx, al                ; write the data out
				mov cx, 33                ; load the loop count
		 lbl2:in al, dx
				loop lbl2
			}
	}
	outp(0x20,0x20);
}

setinst(synth,chan,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10)
int chan;
unsigned char synth,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10;
{
	int offs;

	outdata(synth,0xa0+chan,0);
	outdata(synth,0xb0+chan,0);
	outdata(synth,0xc0+chan,v10);
	offs = adlibchanoffs[chan];
	outdata(synth,0x20+offs,v5);
	outdata(synth,0x40+offs,v6);
	outdata(synth,0x60+offs,v7);
	outdata(synth,0x80+offs,v8);
	outdata(synth,0xe0+offs,v9);
	offs+=3;
	outdata(synth,0x20+offs,v0);
	outdata(synth,0x40+offs,v1);
	outdata(synth,0x60+offs,v2);
	outdata(synth,0x80+offs,v3);
	outdata(synth,0xe0+offs,v4);
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}
